package admin;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Calendar;
import java.util.StringTokenizer;

import javax.imageio.ImageIO;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.filechooser.FileFilter;

import utils.DataUsers;
import utils.ExtensionFileFilter;
import utils.Global;
import utils.NZipCompresser;
import gui.ImageArray;

/**
 *  
 * @author jwdd
 * 
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/.
 */
public class ImportarPicto extends JDialog implements ActionListener, MouseListener
{
	private JLabel frmLabelCSV, frmLabelDirectorio, frmTitulo;
	private JButton frmFichero;
	private JButton frmGenerar;
	private JPanel panelSuperior, panelCentral, panelInferior;
	private String selRutaFicheroCSV = null;
	private String selRutaDirectorio = null;

	private final String tmpDirectorio = Global.TEMP_FOLDER + Global.SEPARADOR_SYS + "tmp_update";
	private final String tmpDirectorioPicto = "picto";
	private final String tmpSQLScript = "insert.sql";

	private final String TXTACTUALIZAROK = Global.LANG.getString("ip_actualizarok");
	private final String TXTACTUALIZARERROR = Global.LANG.getString("ip_actualizarerror");
	private final String TXTSELPICTOGRAMAS = Global.LANG.getString("ip_selpictogramas");
	private final String TXTSELCSV = Global.LANG.getString("ip_selcsv");
	private final String TXTGENERAR = Global.LANG.getString("ip_generar");
	private final String TXTTITULO = Global.LANG.getString("ip_titulo");
	private final String TXTGENERANDO = Global.LANG.getString("ip_generando");
	private final String TXTSOBREESCRIBIR = Global.LANG.getString("ip_sobreescribir");

	public ImportarPicto(VentanaAdminUsuarioSel vant)
	{
		this(600, 350, vant);

		try
		{
			setIconImage(ImageIO.read(new File(Global.IMG_FOLDER + Global.SEPARADOR_SYS + "favicon.png")));
		}
		catch (IOException e)
		{
			// TODO Auto-generated catch block
			System.out.println("No se puede abrir icono.");
			e.printStackTrace();
		}
	}

	public ImportarPicto(int wsize, int hsize, VentanaAdminUsuarioSel vant)
	{
		super(vant, true);
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		getGlassPane().setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));

		try
		{
			setIconImage(ImageIO.read(new File(Global.IMG_FOLDER + Global.SEPARADOR_SYS + "favicon.png")));
		}
		catch (IOException e)
		{
			// TODO Auto-generated catch block
			System.out.println("No se puede abrir icono.");
			e.printStackTrace();
		}
		this.setTitle(TXTTITULO);

		// frmFichero --> NO SE USA NO??
		frmFichero = new JButton();
		frmFichero.setFont(Global.FONT_ADMIN_BUTTON);
		frmFichero.setBorder(BorderFactory.createRaisedBevelBorder());
		frmFichero.setForeground(Global.COLOR_TEXTO_BOTON);
		ImageIcon iuser = new ImageIcon("img/folder_small.png");
		frmFichero.setIcon(iuser);

		// frmGenerar --> Botón para generar la actulización. At the bottom of the window.
		frmGenerar = new JButton(TXTGENERAR + " ");
		frmGenerar.setEnabled(false);
		frmGenerar.setBackground(Color.white);
		frmGenerar.setBorder(BorderFactory.createRaisedBevelBorder());
		frmGenerar.setForeground(Global.COLOR_TEXTO);
		frmGenerar.setFont(Global.FONT_ADMIN_BUTTON);
		ImageIcon icopy = new ImageIcon("img/copy.png");
		frmGenerar.setIcon(icopy);

		// frmLabelCSV --> Texto para seleccionar fichero.
		frmLabelCSV = new JLabel(TXTSELCSV);
		frmLabelCSV.setForeground(Global.COLOR_TEXTO);
		frmLabelCSV.setBorder(new EmptyBorder(10, 10, 10, 10));
		frmLabelCSV.setFont(Global.FONT_ADMIN_USER);

		// frmLabelDirectorio --> Texto para seleccionar directorio de pictogramas.
		frmLabelDirectorio = new JLabel(TXTSELPICTOGRAMAS);
		frmLabelDirectorio.setBorder(new EmptyBorder(10, 10, 10, 10));
		frmLabelDirectorio.setForeground(Global.COLOR_TEXTO);
		frmLabelDirectorio.setFont(Global.FONT_ADMIN_USER);

		// frmTitulo --> Título de la ventana
		frmTitulo = new JLabel(TXTTITULO);
		frmTitulo.setFont(Global.FONT_ADMIN_TITLE);
		frmTitulo.setForeground(Global.COLOR_CONTENIDO);
		ImageIcon iUser = new ImageIcon("img/pictogramas.png");
		frmTitulo.setIcon(iUser);

		// crean las actualizaciones
		this.setSize(wsize, hsize);
		this.setResizable(false);

		poblar();

		frmFichero.addActionListener(this);
		frmGenerar.addActionListener(this);
		frmLabelCSV.addMouseListener(this);
		frmLabelDirectorio.addMouseListener(this);
	}

	private void poblar()
	{
		panelSuperior = new JPanel(new FlowLayout(FlowLayout.LEFT));
		panelCentral = new JPanel(new GridLayout(2, 1));
		panelInferior = new JPanel(new FlowLayout());
		// panelCentral ----------------------------------------------------------------------------------
		// panelCentral.setLayout(new BoxLayout(panelCentral, BoxLayout.Y_AXIS));
		panelCentral.setBorder(BorderFactory.createMatteBorder(1, 20, 1, 20, Global.COLOR_FONDO));
		panelCentral.setBackground(Global.COLOR_CONTENIDO);
		panelCentral.add(frmLabelCSV);
		panelCentral.add(frmLabelDirectorio);
		// panelSuperior ----------------------------------------------------------------------------------
		panelSuperior.add(frmTitulo);
		panelSuperior.setBackground(Global.COLOR_FONDO);
		panelSuperior.setBorder(new EmptyBorder(10, 20, 20, 20));
		// panelInferior ----------------------------------------------------------------------------------
		panelInferior.add(frmGenerar);
		panelInferior.setBorder(new EmptyBorder(20, 20, 20, 20));
		panelInferior.setBackground(Global.COLOR_FONDO);
		// ContentPane ----------------------------------------------------------------------------------
		this.getContentPane().add(panelSuperior, BorderLayout.NORTH);
		this.getContentPane().add(panelCentral, BorderLayout.CENTER);
		this.getContentPane().add(panelInferior, BorderLayout.SOUTH);
	}

	private void seleccionarFicheroCSV()
	{
		JFileChooser fileChooser = new JFileChooser();
		fileChooser.setCurrentDirectory(new File(System.getProperty("user.home")));
		FileFilter filter1 = new ExtensionFileFilter("csv", new String[] { "csv" });
		fileChooser.setFileFilter(filter1);
		int seleccion = fileChooser.showOpenDialog(rootPane);
		if(seleccion == JFileChooser.APPROVE_OPTION)
		{
			selRutaFicheroCSV = fileChooser.getSelectedFile().getAbsolutePath();
			frmLabelCSV.setForeground(Color.green);
			ImageIcon iv = new ImageIcon("img/visto.png");
			frmLabelCSV.setIcon(iv);
			// frmLabelCSV.setIcon(null);
		}

		if(selRutaDirectorio != null && selRutaFicheroCSV != null) frmGenerar.setEnabled(true);
	}

	private void seleccionarCarpeta()
	{
		JFileChooser fileChooser = new JFileChooser();
		fileChooser.setCurrentDirectory(new File(System.getProperty("user.home")));
		fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		FileFilter filter1 = new ExtensionFileFilter("", new String[] { "" });
		fileChooser.setFileFilter(filter1);
		int seleccion = fileChooser.showOpenDialog(rootPane);
		if(seleccion == JFileChooser.APPROVE_OPTION)
		{
			selRutaDirectorio = fileChooser.getSelectedFile().getAbsolutePath();
			frmLabelDirectorio.setForeground(Color.green);
			ImageIcon iv = new ImageIcon("img/visto.png");
			frmLabelDirectorio.setIcon(iv);
		}

		if(selRutaDirectorio != null && selRutaFicheroCSV != null) frmGenerar.setEnabled(true);
	}

	public void actionPerformed(ActionEvent arg0)
	{
		boolean ok = true;
		if(arg0.getSource() == frmGenerar && frmGenerar.getText().equals(TXTGENERAR + " "))
		{
			if(selRutaDirectorio != null && selRutaFicheroCSV != null)
			{
				getGlassPane().setVisible(true);

				DataUsers.deleteDirectory(new File(tmpDirectorio)); // Borra el directorio temporal donde se
				frmGenerar.setText(TXTGENERANDO + " (0%)");
				frmGenerar.paintImmediately(frmGenerar.getVisibleRect());

				ok = leerCSV(selRutaFicheroCSV); // Leo el fichero CSV y creo el fichero de inserts

				frmGenerar.setText(TXTGENERANDO + " (50%)");
				frmGenerar.paintImmediately(frmGenerar.getVisibleRect());

				if(ok)
				{
					Calendar fecha = Calendar.getInstance();
					String dia = Integer.toString(fecha.get(Calendar.DATE));
					String mes = Integer.toString(fecha.get(Calendar.MONTH) + 1);
					String annio = Integer.toString(fecha.get(Calendar.YEAR));

					String fact = "Update PICTO TICa " + dia + "-" + mes + "-" + annio + ".zip"; // Nombre por defecto

					JFileChooser fileChooser = new JFileChooser();
					fileChooser.setCurrentDirectory(new File(System.getProperty("user.home")));
					fileChooser.setSelectedFile(new File(fact));
					FileFilter filter1 = new ExtensionFileFilter("ZIP", new String[] { "zip" }); // Ficheros .zip
					fileChooser.setFileFilter(filter1);
					int seleccion = fileChooser.showSaveDialog(rootPane);
					if(seleccion == JFileChooser.APPROVE_OPTION)
					{
						int res = JOptionPane.YES_OPTION;
						if(fileChooser.getSelectedFile().exists())
						{
							res = JOptionPane.showConfirmDialog(this, TXTSOBREESCRIBIR, "", JOptionPane.YES_NO_OPTION, JOptionPane.INFORMATION_MESSAGE);
						}

						if(res == JOptionPane.YES_OPTION)
						{
							frmGenerar.setText(TXTGENERANDO + " (75%)");
							frmGenerar.paintImmediately(frmGenerar.getVisibleRect());
							fact = fileChooser.getSelectedFile().getAbsolutePath(); // Ruta del fichero seleccionando por el usuario
							copiarPictogramas(); // Copio los pictogramas a la ubicación temporal
							NZipCompresser c = new NZipCompresser(new File(tmpDirectorio), fact);
							try
							{
								c.compress(NZipCompresser.ALLFILES);
							}
							catch (Exception e)
							{
								System.out.println(e);
							}

							frmGenerar.setText(TXTGENERANDO + " (100%)");
							frmGenerar.paintImmediately(frmGenerar.getVisibleRect());
							JOptionPane.showMessageDialog(this, TXTACTUALIZAROK);
							frmGenerar.setEnabled(true);
						}
					}

					// copiarPictogramas(); // Copio los pictogramas a la ubicación temporal
					// Calendar fecha = Calendar.getInstance();
					// String dia = Integer.toString(fecha.get(Calendar.DATE));
					// String mes = Integer.toString(fecha.get(Calendar.MONTH) + 1);
					// String annio = Integer.toString(fecha.get(Calendar.YEAR));
					//
					// String fact = "Update PICTO TICa " + dia + "-" + mes + "-" + annio + ".zip";
					//
					// NZipCompresser c = new NZipCompresser(new File(tmpDirectorio), fact);
					// try
					// {
					// c.compress(NZipCompresser.ALLFILES);
					// }
					// catch (Exception e)
					// {
					// System.out.println(e);
					// }
					// frmGenerar.setText(TXTGENERANDO + " (100%)");
					// frmGenerar.paintImmediately(frmGenerar.getVisibleRect());
					// JOptionPane.showMessageDialog(this, TXTACTUALIZAROK);
					// frmGenerar.setEnabled(true);
				}
				else
				// El fichero CSV contiene errores
				{
					selRutaFicheroCSV = null;
					frmLabelCSV.setForeground(Color.black);
					frmLabelCSV.setIcon(null);
					JOptionPane.showMessageDialog(this, TXTACTUALIZARERROR, "", JOptionPane.WARNING_MESSAGE);
					frmGenerar.setEnabled(false);
				}
				frmGenerar.setText(TXTGENERAR + " ");
				frmGenerar.paintImmediately(frmGenerar.getVisibleRect());

				getGlassPane().setVisible(false);
			}
		}
	}

	private boolean leerCSV(String rutaFichero)
	{
		boolean ok = true;
		File file = new File(rutaFichero); // Fichero con el CSV
		String datos[] = new String[2];
		int i = 0;

		BufferedReader bufRdr = null;
		try
		{
			bufRdr = new BufferedReader(new FileReader(file));
		}
		catch (FileNotFoundException e) // Hay algun tipo de problema con la lectura del fichero
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
			ok = false;
		}
		String line = null;

		try
		{
			while ((line = bufRdr.readLine()) != null) // Leo linea a linea
			{
				i = 0;
				StringTokenizer st = new StringTokenizer(line, "|"); // Separador entre campos
				while (st.hasMoreTokens())
				{
					// Primer elemento el ID de la imagen y el segundo elemento los posibles nombres separados por comas
					datos[i] = st.nextToken();
					i++;
				}
				if(datos[0] != null) ok = CSV2SQL(datos[0], datos[1]);
				datos[0] = null;
				datos[1] = null;
			}
			bufRdr.close();
		}
		catch (Exception e) // Hay algun tipo de problema con el formato de los datos del fichero
		{
			// TODO Auto-generated catch block
			ok = false;
			e.printStackTrace();
		}

		return ok;
	}

	private void copiarPictogramas()
	{
		new File(tmpDirectorio + File.separator + tmpDirectorioPicto).mkdir();
		ImageArray.resizeDir(selRutaDirectorio, tmpDirectorio + File.separator + tmpDirectorioPicto, Global.PICT_EXT, 100, 100, Global.LANG.getString("generadorProgreso"), this);
	}

	/**
	 * Inserta un registro en la tabla de pictogramas
	 * 
	 * @param idPicto
	 *            id del pictograma (imagen)
	 * @param nombres
	 *            Todos los posibles nombres del pictograma separados por ";"
	 */
	private boolean CSV2SQL(String idPicto, String nombres)
	{
		boolean ok = true;
		Statement stat = null; // CSV -> 1,casa;hogar del pensionista;edificio
		ResultSet rs = null; // 2,pelota
		String simb = "1234567890¿?¡!@";
		String letras = "abcdefghijklmnñopqrstuvwxyz";
		String nn = null;
		String tabla = null;
		String strsql = null;

		try
		{
			StringTokenizer st = new StringTokenizer(nombres, ";"); // Separador entre campos nombres
			while (st.hasMoreTokens())
			{
				// Primer elemento el ID de la imagen y el segundo elemento los posibles nombres separados por comas
				nn = st.nextToken();
				nn = nn.trim(); // Elimino caracteres en blanco
				nn = noCaracteresProhibidos(nn); // Eliminamos las comillas simples
				if(!nn.isEmpty())
				{
					tabla = nn.toLowerCase();
					tabla = tabla.substring(0, 1); // Primer caracter
					tabla = notAccent(tabla); // Sin acentos ni cosas raras :)
					// if(simb.indexOf(tabla) != -1) tabla = "noletter"; // Si la palabra es un número o un simbolo
					if(letras.indexOf(tabla) == -1) tabla = "noletter"; // Si la palabra no se encuentra entre las letras y es un simbolo

					strsql = "INSERT INTO " + tabla + "(IMG_ID,TEXTPIC) VALUES('" + idPicto + "','" + nn + "')";
					escribirFicheroSQL(strsql);
				}
			}
		}
		catch (Exception e) // Alguno de los datos del fichero CSV tiene que estar mal
		{
			ok = false;
		}

		return ok;
	}

	/**
	 * Elimina las comillas de una cadena
	 * 
	 * @param str
	 *            la cadena
	 * @return la cadena sin comillas
	 */
	private static String noCaracteresProhibidos(String str)
	{
		str = str.replace("'", " ");
		str = str.replace("(", "");
		str = str.replace(")", "");

		str = str.trim();

		return str;
	}

	/**
	 * Elimina los acentos de una cadena
	 * 
	 * @param str
	 *            La cadena a la que queremos eliminar los acentos.
	 * @return La cadena sin acentos
	 */
	private static String notAccent(String str)
	{
		// Cadena de caracteres original a sustituir.
		String original = "áàäâéèëêíìïóòöôúùuñÁÀÄÉÈËÍÌÏÓÒÖÚÙÜÑçÇ";
		// Cadena de caracteres ASCII que reemplazarán los originales.
		String ascii = "aaaaeeeeiiioooouuunAAAEEEIIIOOOUUUNcC";
		String output = str;

		for (int i = 0; i < original.length(); i++)
		{
			// Reemplazamos los caracteres especiales.
			output = output.replace(original.charAt(i), ascii.charAt(i));
		}

		return output;
	}

	private void escribirFicheroSQL(String Linea)
	{
		FileWriter fichero = null;
		PrintWriter pw = null;
		try
		{
			String ruta = tmpDirectorio + File.separator + tmpSQLScript;
			DataUsers.createFolder(tmpDirectorio);
			fichero = new FileWriter(ruta, true); // Añade al final del fichero
			pw = new PrintWriter(fichero);
			pw.println(Linea);
			fichero.close();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}

	@Override
	public void mouseClicked(MouseEvent e)
	{
		if(e.getSource() == frmLabelCSV)
		{
			seleccionarFicheroCSV();
		}

		if(e.getSource() == frmLabelDirectorio)
		{
			seleccionarCarpeta();
		}
	}

	@Override
	public void mouseEntered(MouseEvent e)
	{
		// TODO Auto-generated method stub
	}

	@Override
	public void mouseExited(MouseEvent e)
	{
		// TODO Auto-generated method stub
	}

	@Override
	public void mousePressed(MouseEvent e)
	{
		// TODO Auto-generated method stub
	}

	@Override
	public void mouseReleased(MouseEvent e)
	{
		// TODO Auto-generated method stub
	}

	public static void main(String arg[])
	{
		try
		{
			ImportarPicto frame = new ImportarPicto(new VentanaAdminUsuarioSel(1));
			frame.setVisible(true);
		}
		catch (Exception e)
		{
			System.out.println(e);
		}
	}
}
