package admin;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.util.Vector;

import javax.imageio.ImageIO;
import javax.swing.BorderFactory;
import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.border.EmptyBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import utils.DataUsers;
import utils.Global;

/**
 *  
 * @author jwdd
 * 
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/.
 */
public class VentanaAdminTeclados extends JDialog implements ListSelectionListener, ActionListener
{
	private JButton frmAceptar;
	private JButton frmCancelar;
	private DefaultListModel defModel;
	private JScrollPane scroller;
	private String[] listaFicheros;
	private JPanel panelInferior;
	private JPanel panelSuperior;
	private JPanel panelCentral;
	private JPanel panelCentral2;
	private JLabel frmTitulo;
	private JButton frmAnadir, frmEliminar;
	private JList frmListaGlobal;
	private JList frmListaUsuario;
	private DefaultListModel modelUsuario;
	private DefaultListModel modelGlobal;
	private JScrollPane frmScrollGlobal;
	private JScrollPane frmScrollUsuario;
	private VentanaAdminUsuarioDetalle ventanaAnterior;

	private String IDUSER;

	private final String TXTELIMINAR = Global.LANG.getString("vat_eliminar");
	private final String TXTANADIR = Global.LANG.getString("vat_anadir");
	private final String TXTTECLADO = Global.LANG.getString("vat_teclado");
	private final String TITULO = Global.LANG.getString("vat_titulo");
	private final String TXTACEPTAR = Global.LANG.getString("vat_aceptar");
	private final String TXTCANCELAR = Global.LANG.getString("vat_cancelar");

	VentanaAdminTeclados(String iduser, VentanaAdminUsuarioDetalle detalle)
	{
		this(iduser, 800, 600, detalle);
		try
		{
			setIconImage(ImageIO.read(new File(Global.IMG_FOLDER + Global.SEPARADOR_SYS + "favicon.png")));
		}
		catch (IOException e)
		{
			// TODO Auto-generated catch block
			System.out.println("No se puede abrir icono.");
			e.printStackTrace();
		}
		this.setTitle(TITULO);
	}

	VentanaAdminTeclados(String iduser, int wsize, int hsize, VentanaAdminUsuarioDetalle detalle)
	{
		super(detalle, true);
		try
		{
			setIconImage(ImageIO.read(new File(Global.IMG_FOLDER + Global.SEPARADOR_SYS + "favicon.png")));
		}
		catch (IOException e)
		{
			// TODO Auto-generated catch block
			System.out.println("No se puede abrir icono.");
			e.printStackTrace();
		}
		this.setTitle(TITULO);
		// this.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		// this.setUndecorated(true);
		// this.getRootPane().setWindowDecorationStyle(JRootPane.QUESTION_DIALOG);

		this.setBounds(detalle.getBounds());
		ventanaAnterior = detalle;
		IDUSER = iduser;
		frmAnadir = new JButton(TXTANADIR);
		ImageIcon iAdd = new ImageIcon("img" + File.separator + "flecha.png");
		frmAnadir.setHorizontalTextPosition(JButton.LEFT);
		frmAnadir.setIcon(iAdd);
		frmAnadir.setFont(Global.FONT_ADMIN_USER);
		// frmAnadir.setBackground(Color.white);
		// frmAnadir.setBorder(BorderFactory.createRaisedBevelBorder());
		frmAnadir.setSelected(false);
		frmAnadir.setForeground(Global.COLOR_TEXTO_BOTON);

		frmEliminar = new JButton(TXTELIMINAR);
		ImageIcon iDel = new ImageIcon("img" + File.separator + "cruzv1.png");
		frmEliminar.setIcon(iDel);
		frmEliminar.setHorizontalTextPosition(JButton.LEFT);
		frmEliminar.setFont(Global.FONT_ADMIN_USER);
		// frmEliminar.setBackground(Color.white);
		// frmEliminar.setBorder(BorderFactory.createRaisedBevelBorder());
		frmEliminar.setSelected(false);
		frmEliminar.setForeground(Global.COLOR_TEXTO_BOTON);

		frmAceptar = new JButton(TXTACEPTAR);
		ImageIcon iOk = new ImageIcon("img" + File.separator + "vistov.png");
		frmAceptar.setIcon(iOk);
		frmAceptar.setHorizontalTextPosition(JButton.LEFT);
		frmAceptar.setFont(Global.FONT_ADMIN_USER);
		// frmAceptar.setBackground(Color.white);
		// frmAceptar.setBorder(BorderFactory.createRaisedBevelBorder());
		frmAceptar.setSelected(false);
		frmAceptar.setForeground(Global.COLOR_TEXTO_BOTON);

		frmCancelar = new JButton(TXTCANCELAR);
		frmCancelar.setFont(Global.FONT_ADMIN_USER);
		frmCancelar.setBackground(Color.white);
		frmCancelar.setBorder(BorderFactory.createRaisedBevelBorder());
		frmCancelar.setForeground(new Color(31, 63, 63));

		// frmTitulo = new JLabel(TXTTECLADO);
		frmTitulo = new JLabel(TITULO);
		frmTitulo.setFont(Global.FONT_ADMIN_TITLE);
		frmTitulo.setForeground(Color.white);
		ImageIcon iUser = new ImageIcon("img" + File.separator + "superuserInf.png");
		frmTitulo.setIcon(iUser);

		modelGlobal = crearModeloRuta(Global.TCV1_FOLDER, Global.TCV2_FOLDER);
		frmListaGlobal = new JList(modelGlobal);
		frmListaGlobal.setFont(Global.FONT_ADMIN_USER);
		frmListaGlobal.setFixedCellWidth(200);
		frmListaGlobal.setMinimumSize(new Dimension(500, frmListaGlobal.getHeight()));

		String putv1 = Global.USERS_FOLDER + File.separator + iduser + File.separator + Global.TCV1_FOLDER;
		String putv2 = Global.USERS_FOLDER + File.separator + iduser + File.separator + Global.TCV2_FOLDER;

		modelUsuario = crearModeloRuta(putv1, putv2);
		frmListaUsuario = new JList(modelUsuario);
		frmListaUsuario.setFont(Global.FONT_ADMIN_USER);
		frmListaUsuario.setFixedCellWidth(200);
		frmScrollGlobal = new JScrollPane(frmListaGlobal);
		frmScrollUsuario = new JScrollPane(frmListaUsuario);

		frmEliminar.setSize(frmScrollUsuario.getWidth(), frmEliminar.getHeight());

		frmListaGlobal.addListSelectionListener(this);
		frmListaUsuario.addListSelectionListener(this);

		frmAnadir.addActionListener(this);
		frmEliminar.addActionListener(this);
		frmAceptar.addActionListener(this);
		frmCancelar.addActionListener(this);

		this.setSize(wsize, hsize);
		this.setResizable(false);
		// this.setUndecorated(true);

		// this.setTitle(TITULO);
		poblar();

		this.pack();
		this.setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);

		// this.setBounds(posicion());
	}

	private Rectangle posicion()
	{
		int d = (int) (ventanaAnterior.getWidth() - this.getWidth()) / 2;

		int d2 = (int) (ventanaAnterior.getHeight() - this.getHeight()) / 2;

		int x = ventanaAnterior.getX() + d;
		int y = ventanaAnterior.getX() + d2;

		return new Rectangle(x, y, 2000, 2000);
	}

	private void poblar()
	{
		panelSuperior = new JPanel(new FlowLayout(FlowLayout.LEFT));
		panelCentral = new JPanel(new FlowLayout());
		panelCentral2 = new JPanel(new BorderLayout());
		panelInferior = new JPanel(new FlowLayout());
		panelSuperior.setBorder(new EmptyBorder(10, 0, 10, 20));
		panelSuperior.setBackground(Global.COLOR_FONDO);
		panelInferior.setBorder(new EmptyBorder(10, 20, 10, 20));
		panelInferior.setBackground(Global.COLOR_FONDO);
		panelCentral.setBackground(Global.COLOR_CONTENIDO);
		// panelCentral.setBorder(new EmptyBorder(10, 10, 10, 10));
		panelCentral.setBorder(BorderFactory.createMatteBorder(1, 10, 1, 10, Global.COLOR_FONDO));

		panelSuperior.add(frmTitulo);
		panelCentral2.add(frmScrollUsuario, BorderLayout.NORTH);
		panelCentral2.add(frmEliminar, BorderLayout.SOUTH);
		panelCentral.add(frmScrollGlobal, BorderLayout.WEST);
		panelCentral.add(frmAnadir, BorderLayout.CENTER);
		panelCentral.add(panelCentral2, BorderLayout.EAST);
		panelInferior.add(frmAceptar);

		this.getContentPane().add(panelSuperior, BorderLayout.NORTH);
		this.getContentPane().add(panelCentral, BorderLayout.CENTER);
		this.getContentPane().add(panelInferior, BorderLayout.SOUTH);
	}

	private DefaultListModel crearModeloRuta(String path)
	{
		DefaultListModel temp = new DefaultListModel();
		Vector datos = DataUsers.getFolderFileList(path);

		if(datos != null)
		{
			for (int i = 0; i < datos.size(); i++)
			{
				temp.addElement((Object) datos.get(i));
			}
		}

		return temp;
	}

	private DefaultListModel crearModeloRuta(String path, String path2)
	{
		DefaultListModel temp = new DefaultListModel();
		Vector datos = DataUsers.getFolderFileList(path, false);
		Vector datos2 = DataUsers.getFolderFileList(path2, false);

		if(datos != null)
		{
			for (int i = 0; i < datos.size(); i++)
			{
				if(datos != null) temp.addElement("TCV1_" + (Object) datos.get(i));
			}
		}

		if(datos2 != null)
		{
			for (int i = 0; i < datos2.size(); i++)
			{
				if(datos != null) temp.addElement("TCV2_" + (Object) datos2.get(i));
			}
		}

		return temp;
	}

	@Override
	public void valueChanged(ListSelectionEvent arg0)
	{
		if(arg0.getSource() == frmListaGlobal)
		{
			Object[] valores = frmListaGlobal.getSelectedValues();
		}
		else if(arg0.getSource() == frmListaUsuario)
		{
			Object[] valores = frmListaUsuario.getSelectedValues();
		}
	}

	private void anadirTeclado(String teclado)
	{
		modelUsuario.removeElement(teclado);
		modelUsuario.addElement(teclado);

		String[] t = teclado.split("_");
		String tt = t[0];
		String tfile = "";
		String fo = "";
		String fd = "";

		for (int i = 1; i < t.length; i++)
		{
			tfile = tfile + t[i]; // Nombre del teclado por si tiene más de una "_"
		}

		if(tt.equals("TCV1"))
		{
			fo = Global.TCV1_FOLDER + File.separator + tfile + "." + Global.TCV_EXT;
			fd = Global.USERS_FOLDER + File.separator + IDUSER + File.separator + Global.TCV1_FOLDER + File.separator + tfile + "." + Global.TCV_EXT;
		}
		else if(tt.equals("TCV2"))
		{
			fo = Global.TCV2_FOLDER + File.separator + tfile + "." + Global.TCV_EXT;
			fd = Global.USERS_FOLDER + File.separator + IDUSER + File.separator + Global.TCV2_FOLDER + File.separator + tfile + "." + Global.TCV_EXT;
		}

		DataUsers.copyFile(new File(fo), new File(fd));
	}

	private void eliminarTeclado(String teclado)
	{
		modelUsuario.removeElement(teclado);

		String[] t = teclado.split("_");
		String tt = t[0];
		String tfile = "";
		String ruta = "";

		for (int i = 1; i < t.length; i++)
		{
			tfile = tfile + t[i]; // Nombre del teclado por si tiene más de una "_"
		}

		if(tt.equals("TCV1"))
		{
			ruta = Global.USERS_FOLDER + File.separator + IDUSER + File.separator + Global.TCV1_FOLDER + File.separator + tfile + "." + Global.TCV_EXT;
		}
		else if(tt.equals("TCV2"))
		{
			ruta = Global.USERS_FOLDER + File.separator + IDUSER + File.separator + Global.TCV2_FOLDER + File.separator + tfile + "." + Global.TCV_EXT;
		}

		new File(ruta).delete(); // Borra el teclado
	}

	public void actionPerformed(ActionEvent arg0)
	{
		if(arg0.getSource() == frmAnadir)
		{
			Object[] valores = frmListaGlobal.getSelectedValues();
			for (int i = 0; i < valores.length; i++)
			{
				anadirTeclado((String) valores[i]);
			}
		}
		else if(arg0.getSource() == frmEliminar)
		{
			Object[] valores = frmListaUsuario.getSelectedValues();
			for (int i = 0; i < valores.length; i++)
			{
				eliminarTeclado((String) valores[i]);
			}
		}
		else if(arg0.getSource() == frmAceptar)
		{
			ventanaAnterior.setEnabled(true);
			ventanaAnterior.comprobarTecladosVirtuales();
			this.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
			this.setVisible(false);
			this.dispose();
		}
	}

	public static void main(String[] args)
	{
		try
		{
			VentanaAdminTeclados frame = new VentanaAdminTeclados("1", new VentanaAdminUsuarioDetalle(1, null));
			frame.setVisible(true);
		}
		catch (Exception e)
		{
			System.out.println(e);
		}
	}

}
