package admin;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.Set;
import java.util.Vector;

import javax.imageio.ImageIO;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JSeparator;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;
import javax.swing.border.TitledBorder;
import javax.swing.filechooser.FileFilter;

import utils.DataUsers;
import utils.ExtensionFileFilter;
import utils.FileFilterTCV;
import utils.Global;
import editor.CustomisedUI;

/**
 *  
 * @author jwdd
 * 
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/.
 */
public class VentanaAdminUsuarioDetalle extends JDialog implements ActionListener
{
	private JButton frmImagen;
	private JTextField frmNombre;
	private JCheckBox frmActivo;
	private JCheckBox[] frmOpciones = null;
	private JButton frmAccion, frmCancelar, frmVerFicheros, frmExportar, frmTareas;

	private JComboBox frmRol;
	private JLabel label1, label2, label3, titulo;
	private JPanel panelSuperior, panelCentral, panelInferior;
	private JPanel panelAux1, panelAux2, panelAux3;
	private JPanel panelTareas1, panelTareas2, panelTareas3;
	private JPanel panelCentral1, panelCentral2, panelCentral3, panelTareas;
	private JSeparator frmSeparador1, frmSeparador2, frmSeparador3, frmSeparador4;

	private VentanaAdminUsuarioSel padre = null;

	private int idUSER;
	private final String TXTACEPTAR = Global.LANG.getString("aceptar");
	private final String TXTMODIFICAR = Global.LANG.getString("vaud_modificar");
	private final String TITULONUEVO = Global.LANG.getString("vaud_titulonuevo");
	private final String TITULOMODIFICAR = Global.LANG.getString("vaud_titulomodificar");
	private final String TITULOVER = Global.LANG.getString("vaud_titulover");
	private final String TXTNOMBRE = Global.LANG.getString("vaud_nombre");
	private final String TXTACTIVO = Global.LANG.getString("vaud_activo");
	private final String TXTCANCELAR = Global.LANG.getString("vaud_cancelar");
	private final String TXTVERFICHEROS = Global.LANG.getString("vaud_verficheros");
	private final String TXTEXPORTAR = Global.LANG.getString("vaud_exportar");
	private final String TXTTGESUSER = Global.LANG.getString("vaud_editarusuario");
	private final String TXTTAREAS = Global.LANG.getString("vaud_tareas");
	private final String TXTSOBREESCRIBIR = Global.LANG.getString("vaud_sobreescribir");
	private final String TXTFUENTE = Global.LANG.getString("xml_fuente");
	private final String TXTCOLOR = Global.LANG.getString("xml_color");
	private final String TXTAUMENTAR = Global.LANG.getString("xml_aumentar");
	private final String TXTDISMINUIR = Global.LANG.getString("xml_disminuir");
	private final String TXTNEGRITA = Global.LANG.getString("xml_negrita");
	private final String TXTCURSIVA = Global.LANG.getString("xml_cursiva");
	private final String TXTSUBRAYADO = Global.LANG.getString("xml_subrayado");
	private final String TXTINIMAGEN = Global.LANG.getString("xml_inimagen");
	private final String TXTINTABLA = Global.LANG.getString("xml_intabla");
	private final String TXTINVINETA = Global.LANG.getString("xml_invineta");
	private final String TXTINNUMERACION = Global.LANG.getString("xml_innumeracion");
	private final String TXTSANGRIA = Global.LANG.getString("xml_sangria");
	private final String TXTINTERLINEADO = Global.LANG.getString("xml_interlineado");
	private final String TXTCOPIARPEGAR = Global.LANG.getString("xml_copiarpegar");
	private final String TXTDESHACER = Global.LANG.getString("xml_deshacer");
	private final String TXTPICTOGRAMAS = Global.LANG.getString("xml_pictogramas");
	private final String TXTTAREASXML = Global.LANG.getString("xml_tareas");
	private final String TXTCAMBIARCOLOR = Global.LANG.getString("xml_cambiarcolor");
	private final String TXTRESALTA = Global.LANG.getString("xml_resalta");
	private final String TXTEXISTEUSUARIO = Global.LANG.getString("vaud_existeusuario");
	private final String TXTTECLADOSVIRTUALES = Global.LANG.getString("tecvirtmin");
	private final String TXTPERFILES = Global.LANG.getString("vaud_perfiles");
	private final String TXTFUNC = Global.LANG.getString("vaud_funcionalidades");
	private final String TXTNUEVOUSUARIO = Global.LANG.getString("vaud_nuevousuario");

	private String nombreUsuario = null;

	public VentanaAdminUsuarioDetalle(int st, VentanaAdminUsuarioSel vant)
	// negativo
	// edición, si es posivito en
	// visualización
	{ // Ejemplo: -7 Edición Id de usuario 7 // 8 Visualización Id de usuario 10
		// *****************************************************************************
		this(st, 320, 240, vant);
		try
		{
			setIconImage(ImageIO.read(new File(Global.IMG_FOLDER + Global.SEPARADOR_SYS + "favicon.png")));
		}
		catch (IOException e)
		{
			// TODO Auto-generated catch block
			System.out.println("No se puede abrir icono.");
			e.printStackTrace();
		}
	}

	public VentanaAdminUsuarioDetalle(int st, int wsize, int hsize, VentanaAdminUsuarioSel vant)
	// negativo
	// edición, si es posivito en
	// visualización
	{ // Ejemplo: -7 Edición Id de usuario 7 // 8 Visualización Id de usuario 10
		// *****************************************************************************
		super(vant, true);
		try
		{
			setIconImage(ImageIO.read(new File(Global.IMG_FOLDER + Global.SEPARADOR_SYS + "favicon.png")));
		}
		catch (IOException e)
		{
			// TODO Auto-generated catch block
			System.out.println("No se puede abrir icono.");
			e.printStackTrace();
		}
		this.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);

		padre = vant;

		idUSER = Math.abs(st); // Guardo el id del usuario
		label1 = new JLabel(TXTNOMBRE);
		label1.setFont(Global.FONT_ADMIN_USER);
		label3 = new JLabel(TXTACTIVO);
		label3.setFont(Global.FONT_ADMIN_USER);
		titulo = new JLabel(TXTTGESUSER);
		titulo.setFont(Global.FONT_ADMIN_TITLE);
		titulo.setForeground(Color.white);

		ImageIcon iPicto = new ImageIcon("img" + File.separator + "superuser.png");
		Image img = iPicto.getImage();
		Image newimg = img.getScaledInstance(50, 50, java.awt.Image.SCALE_SMOOTH);
		ImageIcon iUser = new ImageIcon(newimg);
		titulo.setIcon(iUser);
		frmNombre = new JTextField(15);
		frmNombre.setEditable(false);
		frmNombre.setFont(Global.FONT_ADMIN_USER);
		frmImagen = new JButton();
		frmImagen.setEnabled(false);
		frmImagen.setFont(Global.FONT_ADMIN_USER);
		frmActivo = new JCheckBox();
		frmActivo.setSelected(true);
		frmActivo.setEnabled(false);
		frmActivo.setFont(Global.FONT_ADMIN_USER);
		frmAccion = new JButton(TXTMODIFICAR);
		ImageIcon iEditar = new ImageIcon("img" + File.separator + "editar.png");
		frmAccion.setIcon(iEditar);
		frmAccion.setFont(Global.FONT_ADMIN_USER);
		frmAccion.setSelected(false);
		frmAccion.setForeground(Global.COLOR_TEXTO_BOTON);
		frmAccion.setFont(Global.FONT_ADMIN_BUTTON);
		frmTareas = new JButton(TXTTAREAS);
		frmCancelar = new JButton(TXTCANCELAR);
		frmCancelar.setName("frmCancelar");
		ImageIcon iEliminar = new ImageIcon("img" + File.separator + "cruz.png");
		frmCancelar.setIcon(iEliminar);
		frmCancelar.setFont(Global.FONT_ADMIN_USER);
		frmCancelar.setBackground(Color.white);
		frmCancelar.setBorder(BorderFactory.createRaisedBevelBorder());
		frmCancelar.setForeground(new Color(31, 63, 63));
		frmVerFicheros = new JButton(TXTVERFICHEROS);
		frmVerFicheros.setFont(Global.FONT_ADMIN_USER);
		frmVerFicheros.setBackground(Color.white);
		ImageIcon iVer = new ImageIcon("img" + File.separator + "lupa2.png");
		frmVerFicheros.setIcon(iVer);
		frmVerFicheros.setFont(Global.FONT_ADMIN_BUTTON);
		frmVerFicheros.setSelected(false);
		frmVerFicheros.setForeground(Global.COLOR_TEXTO_BOTON);
		frmSeparador1 = new JSeparator();
		frmSeparador1.setBorder(new EmptyBorder(0, 0, 0, 0));
		frmExportar = new JButton(TXTEXPORTAR);
		frmExportar.setFont(Global.FONT_ADMIN_USER);
		frmExportar.setSelected(false);
		frmExportar.setForeground(Global.COLOR_TEXTO_BOTON);
		ImageIcon iEx = new ImageIcon("img" + File.separator + "exconf.png");
		frmExportar.setIcon(iEx);
		frmExportar.setFont(Global.FONT_ADMIN_BUTTON);
		Vector<String> ve = mostrarRoles();
		frmRol = new JComboBox(ve);
		frmRol.setEnabled(false);
		frmRol.setFont(Global.FONT_ADMIN_USER);

		if(st == 0) // Nuevo
		{
			this.crearCarpetaTemporalUsuario(); // Creo la carpeta temporal con todos los ficheros necesarios
			this.setTitle(TITULONUEVO);
			titulo.setText(TXTNUEVOUSUARIO);
			modoNuevo();
			modoEdicion();
		}
		else if(st > 0) // Ver usuario
		{
			this.setTitle(TITULOVER);
			modoVisualizacion(st); // Cargar los datos en los componentes
		}
		else if(st < 0) // Modo edición
		{
			this.setTitle(TITULOMODIFICAR);
			modoVisualizacion(Math.abs(st)); // Cargar los datos
			modoEdicion(); // Hace que los componentes sean editables
		}

		poblar();
		// comprobarTecladosVirtuales(); // Al cargar comprueblo los teclados virtuales

		this.setSize(wsize, hsize);
		this.repaint();
		this.setResizable(false);
		this.pack();
		this.repaint();

		frmCancelar.addActionListener(this);
		frmRol.addActionListener(this);
		frmAccion.addActionListener(this);
		frmImagen.addActionListener(this);
		frmExportar.addActionListener(this);
		frmVerFicheros.addActionListener(this);
		frmTareas.addActionListener(this);

		for (int i = 0; i < frmOpciones.length; i++)
		{
			frmOpciones[i].addActionListener(this);
		}
	}

	private void crearCarpetaTemporalUsuario()
	{
		String so = Global.USERS_FOLDER + File.separator + Global.USER_DEFAULT_DATA_FOLDER;
		String sd = Global.USERS_FOLDER + File.separator + String.valueOf(Global.USER_DEFAULT_TEMP_ID);

		DataUsers.deleteDirectory(new File(sd)); // Borramos el directorio temporal por si este existe
		DataUsers.copyDirectory(new File(so), new File(sd));
	}

	private void seleccionarImagen()
	{
		JFileChooser fileChooser = new JFileChooser();
		fileChooser.setCurrentDirectory(new File(System.getProperty("user.home")));
		FileFilter filter1 = new ExtensionFileFilter("Images", new String[] { "PNG", "JPG", "JPGE", "BMP" }); // Tipo imágenes
		fileChooser.setFileFilter(filter1);
		int seleccion = fileChooser.showOpenDialog(rootPane);
		if(seleccion == JFileChooser.APPROVE_OPTION)
		{
			String ruta = fileChooser.getSelectedFile().getAbsolutePath();
			establecerImagen(ruta);
		}
	}

	private void exportarConfiguracion()
	{
		String defaultFileName = DataUsers.getUser(idUSER)[1] + "." + Global.CONF_EXT;

		JFileChooser fileChooser = new JFileChooser();
		fileChooser.setCurrentDirectory(new File(System.getProperty("user.home")));
		fileChooser.setSelectedFile(new File(defaultFileName));
		FileFilter filter1 = new ExtensionFileFilter("CFG", new String[] { "CFG" }); // Configuración
		fileChooser.setFileFilter(filter1);
		int seleccion = fileChooser.showSaveDialog(rootPane);
		if(seleccion == JFileChooser.APPROVE_OPTION)
		{
			int res = JOptionPane.YES_OPTION;
			if(fileChooser.getSelectedFile().exists())
			{
				res = JOptionPane.showConfirmDialog(this, TXTSOBREESCRIBIR, "", JOptionPane.YES_NO_OPTION, JOptionPane.INFORMATION_MESSAGE);
			}

			if(res == JOptionPane.YES_OPTION)
			{
				String ruta = fileChooser.getSelectedFile().getAbsolutePath();
				DataUsers.writeImportDocList(String.valueOf(idUSER)); // Genera un txt con los ficheros del usuario ID | TITULO
				DataUsers.exportProfile(String.valueOf(idUSER), ruta);
			}
		}
	}

	private void establecerImagen(String ruta)
	{
		ImageIcon iPicto = new ImageIcon(ruta);
		Image img = iPicto.getImage();
		Image newimg = img.getScaledInstance(75, 75, java.awt.Image.SCALE_SMOOTH);
		ImageIcon newIcon = new ImageIcon(newimg);
		frmImagen.setIcon(newIcon);

		String dest = Global.USERS_FOLDER + File.separator + idUSER + File.separator + Global.USER_AVATAR + Global.PICT_EXT_PUNTO;
		DataUsers.copyFile(new File(ruta), new File(dest));
	}

	private Vector<String> mostrarRoles()
	{
		Statement stat = null;
		ResultSet rs = null;
		Vector<String> ve = new Vector<String>();

		String sql = "SELECT * FROM ROL ORDER BY NAME";

		try
		{
			stat = Global.DB_HANDLER.getStatement();
			rs = stat.executeQuery(sql);
			ve.add("-----------");
			while (rs.next())
			{
				ve.add(rs.getString("NAME"));
			}
			rs.close();
			//stat.close();
		}
		catch (Exception e)
		{
			System.out.println("error");
		}
		return ve;
	}

	private int infoRol(String nombre)
	{
		Statement stat = null;
		ResultSet rs = null;
		Vector<String> ve = new Vector<String>();
		int id = 0;

		String sql = "SELECT ID FROM ROL WHERE NAME='" + nombre + "'";

		try
		{
			stat = Global.DB_HANDLER.getStatement();
			rs = stat.executeQuery(sql);
			id = Integer.parseInt(rs.getString("ID"));
			rs.close();
			//stat.close();
		}
		catch (Exception e)
		{
			System.out.println("error");
		}

		if(nombre.equals("-----------")) // Sin rol
		{
			return 0;
		}

		return id;
	}

	private LinkedHashMap<String, String> infoUsuario(int id)
	{
		LinkedHashMap<String, String> info = new LinkedHashMap<String, String>();
		Statement stat = null;
		ResultSet rs = null;
		int v = 0;

		String sql = "SELECT * FROM USERS WHERE ID=" + id;

		try
		{
			stat = Global.DB_HANDLER.getStatement();
			rs = stat.executeQuery(sql);
			info.put("NAMEUSER", rs.getString("NAMEUSER"));
			info.put("CONFIGUSER", rs.getString("CONFIGUSER"));
			info.put("ENABLE", rs.getString("ENABLE"));
			rs.close();
			//stat.close();
		}
		catch (Exception e)
		{
			System.out.println("error");
		}

		return info;
	}

	private void modoNuevo()
	{
		String img = Global.USERS_FOLDER + File.separator + Global.USER_DEFAULT_DATA_FOLDER + File.separator + Global.USER_AVATAR + Global.PICT_EXT_PUNTO;
		frmAccion.setText(TXTACEPTAR);
		ImageIcon iAceptar = new ImageIcon("img" + File.separator + "visto.png");
		frmAccion.setIcon(iAceptar);

		// no mostrar botones de documentos y de exportar
		// frmExportar.setEnabled(false);
		// frmVerFicheros.setEnabled(false);
		frmExportar.setVisible(false);
		frmVerFicheros.setVisible(false);

		// frmTareas.setEnabled(true);
		// this.comprobarTecladosVirtuales(); // Si tiene ficheros
		crearOpcionesCheck(Global.USER_DEFAULT_TEMP_ID);
		establecerImagen(img);
	}

	/**
	 * Muestra las opciones del editor para un rol
	 * 
	 * @param estado
	 * 
	 */
	private void crearOpcionesCheck(int id)
	{
		String archivoXML, archivoXSD;
		LinkedHashMap<String, String> temp = null;
		int i = 0;
		if(id != 0)
		{
			archivoXML = Global.USERS_FOLDER + File.separator + String.valueOf(id) + File.separator + Global.USER_CONF_XML;
			archivoXSD = Global.USERS_FOLDER + File.separator + String.valueOf(id) + File.separator + Global.USER_CONF_XSD;
		}
		else
		{
			archivoXML = Global.USERS_FOLDER + File.separator + Global.USER_DEFAULT_DATA_FOLDER + File.separator + Global.USER_CONF_XML;
			archivoXSD = Global.USERS_FOLDER + File.separator + Global.USER_DEFAULT_DATA_FOLDER + File.separator + Global.USER_CONF_XSD;
		}

		temp = leerOpcionesXML(archivoXML, archivoXSD);

		if(frmOpciones == null) frmOpciones = new JCheckBox[temp.size()];

		Collection c = temp.values();
		Iterator itr = c.iterator();
		Set keys = temp.keySet();
		Iterator itrkey = keys.iterator();

		while (itr.hasNext() && itrkey.hasNext())
		{
			if(frmOpciones[i] == null) // La primera vez que se crea
			{
				String texto = itrkey.next().toString();
				frmOpciones[i] = new JCheckBox(texto);
				frmOpciones[i].setFont(Global.FONT_ADMIN_USER);
				if(texto.equals("Tareas") || texto.equals("Tarefas") || texto.equals("Tasks"))
				{
					// frmOpciones[i].setEnabled(false);
					frmOpciones[i].setText(TXTTECLADOSVIRTUALES);
				}
			}

			if(itr.next().toString().equals("si"))
			{
				frmOpciones[i].setSelected(true);
			}
			i++;
		}
	}

	/**
	 * Las opciones que se marcarán segun el Rol
	 * 
	 * @param id
	 */
	private void modificarOpcionesRolCheck(int id)
	{
		LinkedHashMap<String, String> temp = null;
		int i = 0;
		String archivoXML = Global.ROL_FOLDER + File.separator + "rol" + String.valueOf(id) + ".xml";
		String archivoXSD = Global.ROL_FOLDER + File.separator + "rol.xsd";

		temp = leerOpcionesXML(archivoXML, archivoXSD);

		Collection c = temp.values();
		Iterator itr = c.iterator();
		Set keys = temp.keySet();
		Iterator itrkey = keys.iterator();

		while (id > 0 && itr.hasNext() && itrkey.hasNext()) // El 0 significa
		// que no hay por lo
		// que no se
		// modifica ninguna
		// de las opciones
		// seleccionandas
		// previamente
		{
			String texto = itrkey.next().toString();
			if(itr.next().toString().equals("si"))
			{
				if(texto.equals("Tareas")) comprobarTecladosVirtualesCopiarDefecto(); // Compruebo que tenga teclados virtuales
				frmOpciones[i].setSelected(true); // y en el caso de que no tenga copio los teclados virtuales por defecto
			}
			else
			{
				// if(!texto.equals("Tareas")) frmOpciones[i].setSelected(false); // Los roles no afectan a las tareas
				frmOpciones[i].setSelected(false);
			}
			i++;
		}
	}

	private LinkedHashMap<String, String> leerOpcionesForm()
	{
		LinkedHashMap<String, String> info = new LinkedHashMap<String, String>();

		for (int i = 0; i < frmOpciones.length; i++)
		{
			String txt = frmOpciones[i].getText();
			// niobe
			// if(txt == null) txt = TXTTAREASXML; // Para la opción tareas
			if(txt == TXTTECLADOSVIRTUALES) txt = TXTTAREASXML; // Para la opción tareas
			String valor;

			if(frmOpciones[i].isSelected())
			{
				valor = "si";
			}
			else
			{
				valor = "no";
			}

			if(txt.equals(TXTFUENTE))
			{
				info.put("fuente", valor);
			}
			else if(txt.equals(TXTCOLOR))
			{
				info.put("color", valor);
			}
			else if(txt.equals(TXTAUMENTAR))
			{
				info.put("aumentar", valor);
			}
			else if(txt.equals(TXTDISMINUIR))
			{
				info.put("disminuir", valor);
			}
			else if(txt.equals(TXTNEGRITA))
			{
				info.put("negrita", valor);
			}
			else if(txt.equals(TXTCURSIVA))
			{
				info.put("cursiva", valor);
			}
			else if(txt.equals(TXTSUBRAYADO))
			{
				info.put("subrayado", valor);
			}
			else if(txt.equals(TXTINIMAGEN))
			{
				info.put("insertarImagen", valor);
			}
			else if(txt.equals(TXTINTABLA))
			{
				info.put("insertarTabla", valor);
			}
			else if(txt.equals(TXTINVINETA))
			{
				info.put("insertarVineta", valor);
			}
			else if(txt.equals(TXTINNUMERACION))
			{
				info.put("insertarNumeracion", valor);
			}
			else if(txt.equals(TXTSANGRIA))
			{
				info.put("sangria", valor);
			}
			else if(txt.equals(TXTINTERLINEADO))
			{
				info.put("interlineado", valor);
			}
			else if(txt.equals(TXTCOPIARPEGAR))
			{
				info.put("copiarOPegar", valor);
			}
			else if(txt.equals(TXTDESHACER))
			{
				info.put("deshacer", valor);
			}
			else if(txt.equals(TXTPICTOGRAMAS))
			{
				info.put("pictogramas", valor);
			}
			else if(txt.equals(TXTTAREASXML)) // Tareas
			{
				info.put("tareas", valor);
			}
			else if(txt.equals(TXTCAMBIARCOLOR))
			{
				info.put("cambiarColorFondo", valor);
			}
			else if(txt.equals(TXTRESALTA))
			{
				info.put("resalta", valor);
			}
		}

		return info;
	}

	private void guardarOpcionesXML(Integer id)
	{
		String archivoXML = Global.USERS_FOLDER + File.separator + String.valueOf(id) + File.separator + Global.USER_CONF_XML;
		String archivoXSD = Global.USERS_FOLDER + File.separator + String.valueOf(id) + File.separator + Global.USER_CONF_XSD;

		LinkedHashMap<String, String> info;
		CustomisedUI bot = null;
		try
		{
			bot = new CustomisedUI(archivoXML, archivoXSD);
		}
		catch (Exception e)
		{
			System.out.println("Ha ocurrido un error al cargar la configuración: " + e);
			e.printStackTrace();
		}

		info = leerOpcionesForm();

		bot.writeElement("fuente", info.get("fuente"));
		bot.writeElement("color", info.get("color"));
		bot.writeElement("aumentar", info.get("aumentar"));
		bot.writeElement("disminuir", info.get("disminuir"));
		bot.writeElement("negrita", info.get("negrita"));
		bot.writeElement("cursiva", info.get("cursiva"));
		bot.writeElement("subrayado", info.get("subrayado"));
		bot.writeElement("insertarImagen", info.get("insertarImagen"));
		bot.writeElement("insertarTabla", info.get("insertarTabla"));
		bot.writeElement("insertarVineta", info.get("insertarVineta"));
		bot.writeElement("insertarNumeracion", info.get("insertarNumeracion"));
		bot.writeElement("sangria", info.get("sangria"));
		bot.writeElement("interlineado", info.get("interlineado"));
		bot.writeElement("copiarOPegar", info.get("copiarOPegar"));
		bot.writeElement("deshacer", info.get("deshacer"));
		bot.writeElement("pictogramas", info.get("pictogramas"));
		bot.writeElement("tareas", info.get("tareas"));
		bot.writeElement("cambiarColorFondo", info.get("cambiarColorFondo"));
		bot.writeElement("resalta", info.get("resalta"));
	}

	private LinkedHashMap<String, String> leerOpcionesXML(String archivoXML, String archivoXSD)
	{
		// String archivoXML = "tmp" + File.separator + "botones.xml";
		// String archivoXSD = "tmp" + File.separator + "botones.xsd";
		LinkedHashMap<String, String> info = new LinkedHashMap<String, String>();

		CustomisedUI bot = null;

		try
		{
			bot = new CustomisedUI(archivoXML, archivoXSD);
		}
		catch (Exception e)
		{
			System.out.println("Ha ocurrido un error al cargar la configuración: " + e);
			e.printStackTrace();
		}

		info.put(TXTFUENTE, bot.readElement("fuente"));
		info.put(TXTCOLOR, bot.readElement("color"));
		info.put(TXTAUMENTAR, bot.readElement("aumentar"));
		info.put(TXTDISMINUIR, bot.readElement("disminuir"));
		info.put(TXTNEGRITA, bot.readElement("negrita"));
		info.put(TXTCURSIVA, bot.readElement("cursiva"));
		info.put(TXTSUBRAYADO, bot.readElement("subrayado"));
		info.put(TXTINIMAGEN, bot.readElement("insertarImagen"));
		info.put(TXTINTABLA, bot.readElement("insertarTabla"));
		info.put(TXTINVINETA, bot.readElement("insertarVineta"));
		info.put(TXTINNUMERACION, bot.readElement("insertarNumeracion"));
		info.put(TXTSANGRIA, bot.readElement("sangria"));
		info.put(TXTINTERLINEADO, bot.readElement("interlineado"));
		info.put(TXTCOPIARPEGAR, bot.readElement("copiarOPegar"));
		info.put(TXTDESHACER, bot.readElement("deshacer"));
		info.put(TXTPICTOGRAMAS, bot.readElement("pictogramas"));
		info.put(TXTTAREASXML, bot.readElement("tareas"));
		info.put(TXTCAMBIARCOLOR, bot.readElement("cambiarColorFondo"));
		info.put(TXTRESALTA, bot.readElement("resalta"));

		return info;
	}

	private void modoEdicion()
	{
		frmNombre.setEditable(true);
		frmActivo.setEnabled(true);
		frmRol.setEnabled(true);
		frmImagen.setEnabled(true);
		frmCancelar.setEnabled(true);
		frmAccion.setText(TXTACEPTAR);
		ImageIcon iAceptar = new ImageIcon("img/visto.png");
		frmAccion.setIcon(iAceptar);
		frmTareas.setEnabled(true);
		// no mostrar botones de documentos y de exportar

		frmExportar.setVisible(false);
		frmVerFicheros.setVisible(false);

		for (int i = 0; i < frmOpciones.length; i++)
		{
			frmOpciones[i].setEnabled(true);
			String texto = frmOpciones[i].getText();
			// niobe
			// if(texto == null) frmOpciones[i].setEnabled(false);
			// if(texto == TXTTECLADOSVIRTUALES) frmOpciones[i].setEnabled(true);
		}
	}

	private int ultimoIdUsuario()
	{
		Statement stat = null;
		ResultSet rs = null;
		Vector<String> ve = new Vector<String>();
		int r = 0;

		String sql = "SELECT MAX(ID) AS ID FROM USERS";

		try
		{
			stat = Global.DB_HANDLER.getStatement();
			rs = stat.executeQuery(sql);
			r = rs.getInt("ID");
			rs.close();
			//stat.close();
		}
		catch (Exception e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return r;
	}

	private void guardarBD(int id)
	{
		Statement stat = null;
		ResultSet rs = null;
		Vector<String> ve = new Vector<String>();
		int activo = 0;
		String sql;
		String nombre = frmNombre.getText();
		if(nombre.length() > 50)
		{
			nombre = nombre.substring(0, 45);
		}
		nombre = nombre.trim();

		if(frmActivo.isSelected() || DataUsers.countActiveUsers() == 2) // Si esta marcado o es el único usuario
		{
			activo = 1;
		}

		if(id == 0) // Nuevo usuario
		{
			sql = "INSERT INTO USERS(NAMEUSER,ENABLE) VALUES ('" + nombre + "'," + activo + ")";
		}
		else
		// Modificar usuario
		{
			sql = "UPDATE USERS SET NAMEUSER='" + nombre + "',ENABLE=" + activo + " WHERE ID=" + id;
		}

		try
		{
			stat = Global.DB_HANDLER.getStatement();;
			stat.executeUpdate(sql);
			//stat.close();
		}
		catch (Exception e)
		{
			System.out.println(e);
		}

		if(id == 0) idUSER = ultimoIdUsuario();
	}

	private void modoVisualizacion(int id)
	{
		DataUsers.writeUserName(id); // Fichero de texto con el nombre del usuario
		crearOpcionesCheck(id);
		frmAccion.setText(TXTMODIFICAR);
		ImageIcon iEditar = new ImageIcon("img/editar.png");
		frmAccion.setIcon(iEditar);
		frmNombre.setEditable(false);
		frmActivo.setEnabled(false);
		frmRol.setEnabled(false);
		frmImagen.setEnabled(false);
		frmCancelar.setEnabled(false);
		frmTareas.setEnabled(false);
		// Ver botones de exportar y docuemntos
		frmExportar.setVisible(true);

		if(DataUsers.hasDocs(String.valueOf(idUSER))) // Si no tiene documentos no se muestra el boton
		{
			frmVerFicheros.setVisible(true);
		}
		else
		{
			frmVerFicheros.setVisible(false);
		}

		for (int i = 0; i < frmOpciones.length; i++)
		{
			frmOpciones[i].setEnabled(false);
		}

		LinkedHashMap<String, String> temp = null;
		frmAccion.setText(TXTMODIFICAR);

		temp = infoUsuario(id);

		frmNombre.setText(temp.get("NAMEUSER"));

		nombreUsuario = temp.get("NAMEUSER");

		if(temp.get("ENABLE").equals("1"))
		{
			frmActivo.setSelected(true);
		}
		else
		{
			frmActivo.setSelected(false);
		}

		String rutaimg = Global.USERS_FOLDER + File.separator + String.valueOf(id) + File.separator + Global.USER_AVATAR + Global.PICT_EXT_PUNTO;

		if(rutaimg != null)
		{
			ImageIcon iPicto = new ImageIcon(rutaimg);
			Image img = iPicto.getImage();
			Image newimg = img.getScaledInstance(75, 75, java.awt.Image.SCALE_SMOOTH);
			ImageIcon newIcon = new ImageIcon(newimg);
			frmImagen.setIcon(newIcon);
		}
		// this.validate(); // this.repaint();
	}

	private void poblar()
	{
		// panelSuperior: sólo contiene el título (header) ---------------------------------------------------------------------------------------
		panelSuperior = new JPanel(new GridLayout(1, 2)); // Filas,Columnas
		panelSuperior.setBorder(new EmptyBorder(5, 5, 10, 5));
		panelSuperior.setBackground(Global.COLOR_FONDO);
		panelSuperior.add(titulo);

		// panelCentral: contiene el contenido de la ventana --------------------------------------------------------------------------------------
		// panelCentral = new JPanel(new GridLayout(2, 1));
		panelTareas1 = new JPanel();
		panelTareas1.setLayout(new BoxLayout(panelTareas1, BoxLayout.Y_AXIS));
		panelTareas1.setBackground(Global.COLOR_CONTENIDO);

		panelTareas2 = new JPanel();
		panelTareas2.setLayout(new BoxLayout(panelTareas2, BoxLayout.Y_AXIS));
		panelTareas2.setBackground(Global.COLOR_CONTENIDO);

		panelTareas3 = new JPanel();
		panelTareas3.setLayout(new BoxLayout(panelTareas3, BoxLayout.Y_AXIS));
		panelTareas3.setBackground(Global.COLOR_CONTENIDO);

		panelCentral = new JPanel();
		panelCentral.setLayout(new BoxLayout(panelCentral, BoxLayout.Y_AXIS));
		panelCentral.setBorder(new EmptyBorder(0, 5, 15, 5));
		panelCentral.setBackground(Global.COLOR_CONTENIDO);

		panelCentral1 = new JPanel(); // panelCentral1: Nombre y Activo
		panelCentral1.setLayout(new BoxLayout(panelCentral1, BoxLayout.X_AXIS));

		panelCentral1.setBackground(Global.COLOR_CONTENIDO);
		panelCentral2 = new JPanel(); // Nombre, Activo + Imagen
		panelCentral2.setLayout(new FlowLayout(FlowLayout.LEFT));
		panelCentral2.setBorder(BorderFactory.createEmptyBorder(0, 10, 0, 10));
		panelCentral2.setBackground(Global.COLOR_CONTENIDO);
		panelCentral2.add(label1);
		panelCentral2.add(frmNombre);

		panelCentral3 = new JPanel(); // Nombre, Activo + Imagen
		panelCentral3.setLayout(new FlowLayout());
		panelCentral3.setBackground(Global.COLOR_CONTENIDO);
		panelCentral3.add(label3, BorderLayout.WEST);
		panelCentral3.add(frmActivo);
		frmActivo.setBackground(Global.COLOR_CONTENIDO);
		panelCentral1.add(panelCentral2);
		panelCentral1.add(panelCentral3, BorderLayout.WEST);

		panelAux1 = new JPanel(); // Nombre, Activo + Imagen
		panelAux1.setLayout(new GridLayout(1, 3));
		panelAux1.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
		panelAux1.setBackground(Global.COLOR_CONTENIDO);

		panelAux1.add(frmImagen);
		panelAux1.add(panelCentral2);
		panelAux1.add(panelCentral3);
		// panelAux1.add(panelCentral1);

		// panelAux2 = new JPanel(new GridLayout(2, 1)); // Filas,Columnas
		panelAux2 = new JPanel(); // Filas,Columnas
		panelAux2.setLayout(new BoxLayout(panelAux2, BoxLayout.Y_AXIS));
		panelAux2.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
		panelAux2.setBackground(Global.COLOR_CONTENIDO);

		panelAux3 = new JPanel(new GridLayout(1, 3)); // Filas,Columnas
		// panelAux3.setLayout(new FlowLayout());
		panelAux3.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
		panelAux3.setBackground(Global.COLOR_CONTENIDO);
		// panelAux3.add(frmRol); // Tipo de Usuario - Combo y opciones

		frmRol.setBackground(Color.white);
		for (int i = 0; i < frmOpciones.length; i++)
		{
			frmOpciones[i].setBackground(Global.COLOR_CONTENIDO);
			String texto = frmOpciones[i].getText();
			// niobe
			// if(texto == null) // Si son las tareas
			if(texto == TXTTECLADOSVIRTUALES)
			{
				panelTareas = new JPanel(); // Nombre, Activo + Imagen
				panelTareas.setLayout(new FlowLayout(FlowLayout.CENTER));
				panelTareas.setBackground(Global.COLOR_CONTENIDO);
				panelTareas.add(frmOpciones[i]);
				panelTareas.add(frmTareas);
			}
			else
			{
				if(i <= 6) // 1 panel
				{
					panelTareas1.add(frmOpciones[i]);
				}
				else if(i > 6 && i <= 12) // 2 panel
				{
					panelTareas2.add(frmOpciones[i]);
				}
				else if(i > 12) // 3 panel
				{
					panelTareas3.add(frmOpciones[i]);
				}
			}
		}
		panelTareas3.add(panelTareas);
		panelAux3.add(panelTareas1);
		panelAux3.add(panelTareas2);
		panelAux3.add(panelTareas3);

		// panelCentral = new JPanel(new GridLayout(1, 2));

		// niobe añadir titulos

		TitledBorder titlePerfil, titleFunc;
		titlePerfil = BorderFactory.createTitledBorder(TXTPERFILES);
		titleFunc = BorderFactory.createTitledBorder(TXTFUNC);
		titlePerfil.setTitleFont(Global.FONT_ADMIN_USER);
		titleFunc.setTitleFont(Global.FONT_ADMIN_USER);
		titleFunc.setTitleColor(Global.COLOR_FONDO);
		titlePerfil.setTitleColor(Global.COLOR_FONDO);
		frmRol.setBorder(titlePerfil);
		panelAux3.setBorder(titleFunc);

		panelAux2.add(frmRol);
		panelAux2.add(Box.createRigidArea(new Dimension(0, 15)));
		panelAux2.add(panelAux3);

		// diseño- niobe
		panelCentral.add(panelAux1);
		panelCentral.add(panelAux2);
		// panelCentral.setBorder(BorderFactory.createLineBorder(Global.COLOR_BORDE));
		panelCentral.setBackground(Color.white);
		panelCentral.setBorder(BorderFactory.createMatteBorder(1, 5, 1, 5, Global.COLOR_FONDO));

		// panelInferior: contiene los botones (footer) --------------------------------------------------------------------------------------------
		panelInferior = new JPanel(new GridLayout(1, 3));
		panelInferior.setBorder(new EmptyBorder(10, 5, 10, 5));
		panelInferior.setBackground(Global.COLOR_FONDO);
		panelInferior.add(frmVerFicheros);
		panelInferior.add(frmExportar);
		panelInferior.add(frmAccion);

		this.getContentPane().add(panelSuperior, BorderLayout.NORTH);
		this.getContentPane().add(panelCentral, BorderLayout.CENTER);
		this.getContentPane().add(panelInferior, BorderLayout.SOUTH);
	}

	public void actionPerformed(ActionEvent arg0)
	{
		if(arg0.getSource() == frmCancelar)
		{
			try
			{
				this.finalize();
			}
			catch (Throwable e)
			{
				e.printStackTrace();
			}
		}
		else if(arg0.getSource() == frmAccion)
		{
			boolean ne = DataUsers.existUserName(frmNombre.getText()); // Comprueba si el nombre existe

			if(ne && idUSER == 0) JOptionPane.showMessageDialog(this, TXTEXISTEUSUARIO, "", JOptionPane.INFORMATION_MESSAGE); // Mensaje de informacion el usuario ya existe
			if(ne && idUSER > 0 && !this.nombreUsuario.equals(frmNombre.getText())) JOptionPane.showMessageDialog(this, TXTEXISTEUSUARIO, "", JOptionPane.INFORMATION_MESSAGE); // Mensaje de
			// informacion el
			// usuario ya existe
			if(frmAccion.getText().equals(TXTACEPTAR) && frmNombre.getText().length() > 0 && (ne == false || this.nombreUsuario.equals(frmNombre.getText()))) // Si le das aceptar, tiene nombre y no
			// existe el nombre
			{
				if(idUSER == 0)
				{
					guardarBD(idUSER); // Guarda el nuevo usuario en la BD
					DataUsers.createUserProfile(idUSER); // Crea la estructura de ficheros y directorios para el nuevo usuario
					this.setVisible(false);
					this.dispose();
				}
				else
				{
					guardarBD(idUSER);
				}

				guardarOpcionesXML(idUSER);
				DataUsers.writeUserName(idUSER);
				modoVisualizacion(idUSER);
				this.setTitle(TITULOVER);
				frmExportar.setEnabled(true);
				frmVerFicheros.setEnabled(true);
			}
			else if(frmAccion.getText().equals(TXTMODIFICAR))
			{
				modoEdicion();
				this.setTitle(TITULOMODIFICAR);
			}
		}
		else if(arg0.getSource() == frmRol)
		{
			String rol = (String) frmRol.getSelectedItem();
			int id = infoRol(rol);
			modificarOpcionesRolCheck(id);
		}
		else if(arg0.getSource() == frmImagen)
		{
			// if(idUSER != 0) seleccionarImagen();
			seleccionarImagen();
		}
		else if(arg0.getSource() == frmExportar)
		{
			exportarConfiguracion();
		}
		else if(arg0.getSource() == frmVerFicheros)
		{
			if(idUSER != 0) verFicherosUsuarios(); // No se puede ver los ficheros de un usuario si lo estamos creando
		}
		else if(arg0.getSource() == frmTareas)
		{
			verTecladosVirtuales();
		}

		for (int i = 0; i < frmOpciones.length; i++)
		{
			if(arg0.getSource() == frmOpciones[i])
			{
				if(frmOpciones[i].getText().equals("Tareas") && frmOpciones[i].isSelected())
				{
					// System.out.println(frmOpciones[i].getText());
					// verTecladosVirtuales();
				}
			}
		}
	}

	private void verTecladosVirtuales()
	{
		// this.setEnabled(false); // Mientras se muestra la pantalla de teclados virtuales la ventana detalle se bloquea
		VentanaAdminTeclados frame = new VentanaAdminTeclados(String.valueOf(idUSER), this);
		frame.setVisible(true);
	}

	private void verFicherosUsuarios()
	{
		VentanaAdminUsuarioFicheros frame = new VentanaAdminUsuarioFicheros(0, idUSER);
		frame.setVisible(true);
	}

	public void comprobarTecladosVirtualesCopiarDefecto() // Comprueba si un usuario tiene teclados virtuales asignados
	{ // y en caso de no tener copia los teclados virtuales por defecto
		FileFilterTCV filtro = new FileFilterTCV();

		String tcv1 = Global.USERS_FOLDER + File.separator + idUSER + File.separator + Global.TCV1_FOLDER;
		String tcv2 = Global.USERS_FOLDER + File.separator + idUSER + File.separator + Global.TCV2_FOLDER;

		String tcv1_default = Global.USERS_FOLDER + File.separator + Global.USER_DEFAULT_DATA_FOLDER + File.separator + Global.TCV1_FOLDER;
		String tcv2_default = Global.USERS_FOLDER + File.separator + Global.USER_DEFAULT_DATA_FOLDER + File.separator + Global.TCV2_FOLDER;

		if(DataUsers.isEmptyFolder(tcv1, filtro) && DataUsers.isEmptyFolder(tcv2, filtro))
		{
			DataUsers.copyDirectory(new File(tcv1_default), new File(tcv1));
			DataUsers.copyDirectory(new File(tcv2_default), new File(tcv2));
		}
	}

	public void comprobarTecladosVirtuales()
	{
		FileFilterTCV filtro = new FileFilterTCV();

		String tcv1 = Global.USERS_FOLDER + File.separator + idUSER + File.separator + Global.TCV1_FOLDER;
		String tcv2 = Global.USERS_FOLDER + File.separator + idUSER + File.separator + Global.TCV2_FOLDER;

		if(DataUsers.isEmptyFolder(tcv1, filtro) && DataUsers.isEmptyFolder(tcv2, filtro))
		{
			for (int i = 0; i < frmOpciones.length; i++)
			{
				String texto = frmOpciones[i].getText();
				// niobe
				// if(texto == null)
				if(texto == TXTTECLADOSVIRTUALES)
				{
					frmOpciones[i].setSelected(false); // Si no hay teclados se desmarcan las tareas
					frmOpciones[i].setEnabled(false);
				}
			}
		}
		else
		{
			for (int i = 0; i < frmOpciones.length; i++)
			{
				String texto = frmOpciones[i].getText();
				// niobe
				// if(texto == null)
				if(texto == TXTTECLADOSVIRTUALES)
				{
					// frmOpciones[i].setSelected(true);
					frmOpciones[i].setEnabled(true);
				}
			}
		}
	}

	public static void main(String[] args)
	{
		try
		{
			VentanaAdminUsuarioDetalle fr = new VentanaAdminUsuarioDetalle(Global.USER_DEFAULT_TEMP_ID, new VentanaAdminUsuarioSel(1));
			fr.pack();
			fr.setVisible(true);
		}
		catch (Exception e)
		{
			System.out.println(e);
		}
	}
}
