package admin;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dialog;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.Set;
import java.util.Vector;

import javax.imageio.ImageIO;
import javax.swing.BorderFactory;
import javax.swing.DefaultListModel;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ScrollPaneConstants;
import javax.swing.border.EmptyBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import utils.CheckList;
import utils.DataUsers;
import utils.Global;

/**
 *  
 * @author jwdd
 * 
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/.
 */
public class VentanaAdminUsuarioFicheros extends JDialog implements ListSelectionListener, ActionListener
{
	private CheckList chkList;
	private DefaultListModel defModel;
	private JScrollPane scroller;
	private String[] listaFicheros;
	private Vector<String> selFicheros;
	private JPanel panelInferior;
	private JPanel panelSuperior;
	private JLabel frmTitulo;
	private JButton frmExportar, frmEliminar;
	private int actPag, idUSER;

	private final int NMAXFICHPAG = 2000; // Nº de ficheros por página
	private final String TXTELIMINAR = Global.LANG.getString("vauf_eliminar");
	private final String TXTSIGUIENTE = Global.LANG.getString("vauf_siguiente");
	private final String TXTFICHEROS = Global.LANG.getString("vauf_ficheros");
	private final String TXTINFOBORRADO = Global.LANG.getString("vauf_infoborrado");

	private final String TITULO = Global.LANG.getString("vauf_titulo");

	VentanaAdminUsuarioFicheros(int pag, int userid)
	{
		this(pag, userid, 800, 600);
		try
		{
			setIconImage(ImageIO.read(new File(Global.IMG_FOLDER + Global.SEPARADOR_SYS + "favicon.png")));
		}
		catch (IOException e)
		{
			// TODO Auto-generated catch block
			System.out.println("No se puede abrir icono.");
			e.printStackTrace();
		}
		this.setTitle(TITULO);
	}

	VentanaAdminUsuarioFicheros(int pag, int userid, int wsize, int hsize)
	{
		super(null, Dialog.ModalityType.APPLICATION_MODAL);
		try
		{
			setIconImage(ImageIO.read(new File(Global.IMG_FOLDER + Global.SEPARADOR_SYS + "favicon.png")));
		}
		catch (IOException e)
		{
			// TODO Auto-generated catch block
			System.out.println("No se puede abrir icono.");
			e.printStackTrace();
		}
		this.setTitle(TITULO);
		this.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		frmEliminar = new JButton(TXTELIMINAR);
		frmEliminar.setFont(Global.FONT_ADMIN_BUTTON);
		// frmEliminar.setBackground(Color.white);
		// frmEliminar.setBorder(BorderFactory.createRaisedBevelBorder());
		frmEliminar.setSelected(false);
		frmEliminar.setForeground(Global.COLOR_TEXTO_BOTON);
		ImageIcon icopy = new ImageIcon("img/cruz.png");
		frmEliminar.setIcon(icopy);

		// frmEliminar.setBorder(new EmptyBorder(0, 0, 0, 200));
		frmTitulo = new JLabel(TXTFICHEROS + DataUsers.getUser(userid)[1]);
		frmTitulo.setFont(Global.FONT_ADMIN_TITLE);
		frmTitulo.setForeground(Color.white);
		ImageIcon iUser = new ImageIcon("img/superuserInf.png");
		frmTitulo.setIcon(iUser);
		// scroller.setFont(Global.FONT_ADMIN_TITLE);

		selFicheros = new Vector<String>();

		this.setSize(wsize, hsize);
		this.setResizable(false);
		crearCheckList(pag, userid);

		scroller = new JScrollPane(chkList, ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS, ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
		// scroller.setFont(Global.FONT_ADMIN_TITLE);

		poblar();
		// this.pack();
		chkList.setFont(Global.FONT_ADMIN_USER);
		chkList.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		chkList.addListSelectionListener(this);
		// frmExportar.addActionListener(this);
		frmEliminar.addActionListener(this);

		actPag = pag;
		idUSER = userid;
	}

	private void actualizarListaFicheros()
	{
		selFicheros = null;
		selFicheros = new Vector<String>();

		chkList = null;
		defModel = null;
		listaFicheros = null;

		crearCheckList(0, idUSER);

		scroller = null;
		scroller = new JScrollPane(chkList, ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS, ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);

		scroller.setBorder(BorderFactory.createMatteBorder(1, 20, 1, 20, Global.COLOR_FONDO));
		scroller.setBackground(Global.COLOR_CONTENIDO);

		chkList.setFont(Global.FONT_ADMIN_USER);
		chkList.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
		chkList.addListSelectionListener(this);

		this.getContentPane().remove(scroller);
		this.getContentPane().repaint();
		this.getContentPane().add(scroller, BorderLayout.CENTER);
		this.getContentPane().repaint();

		chkList.repaint();
		chkList.revalidate();
		scroller.repaint();
		scroller.revalidate();
		this.repaint();
		this.repaint();
		this.getContentPane().repaint();
	}

	private void eliminarFicheros()
	{
		for (int i = 0; i < selFicheros.size(); i++)
		{
			String iddoc = selFicheros.get(i);
			DataUsers.deleteDocumentFileAndDB(iddoc, String.valueOf(idUSER));
		}
	}

	private LinkedHashMap<String, String> listarFicheros(int pag, int userid)
	{
		LinkedHashMap<String, String> info = new LinkedHashMap<String, String>();
		Statement stat = null;
		ResultSet rs = null;
		String strfichero = "";
		int n = 0;

		String sql = "SELECT ID,TITLE FROM DOCS WHERE USER_ID=" + userid + " ORDER BY TITLE";

		try
		{
			stat = Global.DB_HANDLER.getStatement();;
			rs = stat.executeQuery(sql);
			int inicio = pag * NMAXFICHPAG;
			int fin = inicio + NMAXFICHPAG;

			while (rs.next())
			{
				if(n >= inicio && n < fin)
				{
					strfichero = rs.getString("TITLE");
					if(strfichero.length() > 50) strfichero = strfichero.substring(0, 50) + " ..."; // Por si el nombre del documento es muy grande
					info.put(rs.getString("ID"), strfichero);
				}
				n++;
			}

			rs.close();
			//stat.close();
		}
		catch (Exception e)
		{
			System.out.println(e);
		}

		return info;
	}

	private void crearCheckList(int pag, int userid)
	{
		LinkedHashMap<String, String> temp;
		chkList = new CheckList();
		defModel = new DefaultListModel();
		chkList.setModel(defModel);
		temp = listarFicheros(pag, userid);
		Collection c = temp.values();
		Iterator itr = c.iterator();
		Set keys = temp.keySet();
		Iterator itrkey = keys.iterator();
		int n = 0;
		listaFicheros = new String[temp.size()];

		while (itr.hasNext() && itrkey.hasNext())
		{
			defModel.addElement(itr.next().toString());
			listaFicheros[n] = itrkey.next().toString();
			n++;
		}
	}

	private int siguientePag(int pagact, int nficheros)
	{
		int x = pagact * NMAXFICHPAG;

		if(nficheros > (x + NMAXFICHPAG))
		{
			return pagact + 1;
		}
		else
		{
			return 0;
		}
	}

	private int numFicheros(int userid)
	{
		Statement stat = null;
		ResultSet rs = null;
		int n = 0;

		String sql = "SELECT COUNT(ID) AS NUM FROM DOCS WHERE USER_ID=" + userid;

		try
		{
			stat = Global.DB_HANDLER.getStatement();;
			rs = stat.executeQuery(sql);

			if(rs.next())
			{
				n = rs.getInt("NUM");
			}
			rs.close();
			//stat.close();
		}
		catch (Exception e)
		{
			System.out.println(e);
		}

		return n;
	}

	public void valueChanged(ListSelectionEvent lse)
	{
		if(!lse.getValueIsAdjusting())
		{
			chkList.removeListSelectionListener(this);
			// remember everything selected as a result of this action
			HashSet newSelections = new HashSet();
			int size = chkList.getModel().getSize();
			for (int i = 0; i < size; i++)
			{
				if(chkList.getSelectionModel().isSelectedIndex(i))
				{
					newSelections.add(new Integer(i));
				}
			}
			// turn on everything that was previously selected
			Iterator it = chkList.selectionCache.iterator();
			while (it.hasNext())
			{
				int index = ((Integer) it.next()).intValue();
				// System.out.println("adding " + index);
				chkList.getSelectionModel().addSelectionInterval(index, index);
			}

			// add or remove the delta
			it = newSelections.iterator();
			while (it.hasNext())
			{
				Integer nextInt = (Integer) it.next();
				int index = nextInt.intValue();
				if(chkList.selectionCache.contains(nextInt))
					chkList.getSelectionModel().removeSelectionInterval(index, index);
				else
					chkList.getSelectionModel().addSelectionInterval(index, index);
			}
			// save selections for next time
			chkList.selectionCache.clear();
			selFicheros.clear();
			for (int i = 0; i < size; i++)
			{
				if(chkList.getSelectionModel().isSelectedIndex(i))
				{
					chkList.selectionCache.add(new Integer(i));
					selFicheros.add(listaFicheros[i]);
				}
			}
			chkList.addListSelectionListener(this);
		}
	}

	public void actionPerformed(ActionEvent arg0)
	{
		if(arg0.getSource() == frmEliminar)
		{
			if(selFicheros.size() > 0) // Si hay ficheros seleccionados
			{
				eliminarFicheros();
				JOptionPane.showMessageDialog(this, TXTINFOBORRADO, "", JOptionPane.INFORMATION_MESSAGE); // Mensaje de informacion el usuario ya existe
				// actualizarListaFicheros();
				this.setVisible(false);
				this.dispose();
			}
		}
	}

	/*
	 * private void actualizarVentana(int pag, int iduser) { VentanaAdminUsuarioFicheros frame = null; frame = new VentanaAdminUsuarioFicheros(pag, iduser); frame.setBounds(this.getBounds());
	 * frame.setVisible(true); this.dispose(); }
	 */
	private void poblar()
	{
		panelSuperior = new JPanel(new GridLayout(1, 2));
		panelInferior = new JPanel(new FlowLayout());
		panelSuperior.setBorder(new EmptyBorder(20, 20, 20, 20));
		panelSuperior.setBackground(Global.COLOR_FONDO);
		// scroller.setBorder(BorderFactory.createLineBorder(Global.COLOR_BORDE));
		scroller.setBorder(BorderFactory.createMatteBorder(1, 20, 1, 20, Global.COLOR_FONDO));
		scroller.setBackground(Global.COLOR_CONTENIDO);
		panelInferior.setBorder(new EmptyBorder(20, 20, 20, 20));
		panelInferior.setBackground(Global.COLOR_FONDO);

		panelSuperior.add(frmTitulo, BorderLayout.WEST);
		panelInferior.add(frmEliminar);

		this.getContentPane().add(panelSuperior, BorderLayout.NORTH);
		this.getContentPane().add(scroller, BorderLayout.CENTER);
		this.getContentPane().add(panelInferior, BorderLayout.SOUTH);
	}

	public static void main(String[] args)
	{
		VentanaAdminUsuarioFicheros frame = new VentanaAdminUsuarioFicheros(0, 1);
		frame.setVisible(true);
	}
}
