package admin;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dialog;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.filechooser.FileFilter;

import utils.DataUsers;
import utils.ExtensionFileFilter;
import utils.Global;

/**
 *  
 * @author jwdd
 * 
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/.
 */
public class VentanaAdminUsuarioSel extends JDialog implements ActionListener
{
	private final int PICT_SIZE = 50; // Tamaño de las imagenes de los usuarios PICT_SIZE x PICT_SIZE
	private final int NMAXUSER = 30; // Número total de usuarios que se pueden
	private final int NMAXPAGUSER = 30; // Nº de usuarios por página
	private final String TITULO = Global.LANG.getString("vaus_titulo");
	private final String TXTUSUARIOS = Global.LANG.getString("vaus_usuarios");
	private final String TXTCREAR = Global.LANG.getString("vaus_crear");
	private final String TXTEI = Global.LANG.getString("vaus_tei");
	private final String TXTSALIR = Global.LANG.getString("vaus_salir");
	private final String TXTSIGUIENTE = Global.LANG.getString("vaus_siguiente");
	private final String TXTIMPORTAR = Global.LANG.getString("vaus_importar");
	private final String TXTMAXUSER = Global.LANG.getString("vaus_maxuser");
	private final String TXTUPDATEPICT = Global.LANG.getString("vaus_update");
	private final String TXTACTUALIZARERROR = Global.LANG.getString("vaus_actualizarerror");
	private final String TXTGENERADOR = Global.LANG.getString("vaus_generador");
	private final String TXTIMPORTANDOPICT = Global.LANG.getString("vaus_importandopict");

	private String sListaUsrCambio;

	private Integer nPagina = null; // Pagina actual

	public JButton frmGenerador;
	public JButton frmSiguiente;
	public JButton frmSalir;
	public JButton frmAdmin;
	public JButton frmNuevo;
	public JButton frmCopiar;
	public JButton frmImportar;
	public JButton frmActPictogramas;
	JButton[] frmUsuarios;
	JPanel panelSuperior, panelInferior, panelCentral;
	// JFileChooser fileChooser;

	JLabel label1;

	public VentanaAdminUsuarioSel(int pag)
	{
		this(pag, 1000, 600);
		try
		{
			setIconImage(ImageIO.read(new File(Global.IMG_FOLDER + Global.SEPARADOR_SYS + "favicon.png")));
		}
		catch (IOException e)
		{
			// TODO Auto-generated catch block
			System.out.println("No se puede abrir icono.");
			e.printStackTrace();
		}
	}

	public VentanaAdminUsuarioSel(int pag, int wsize, int hsize)
	{
		super(null, Dialog.ModalityType.APPLICATION_MODAL);

		this.nPagina = pag;

		sListaUsrCambio = "";

		try
		{
			setIconImage(ImageIO.read(new File(Global.IMG_FOLDER + Global.SEPARADOR_SYS + "favicon.png")));
		}
		catch (IOException e)
		{
			// TODO Auto-generated catch block
			System.out.println("No se puede abrir icono.");
			e.printStackTrace();
		}
		int sigpag, nusers, nelementos;

		this.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE); // Cierrate si le dan a la X
		this.setTitle(TITULO);
		label1 = new JLabel();
		label1.setText(TXTUSUARIOS + "                                             ");

		ImageIcon iPicto = new ImageIcon("img" + File.separator + "superuser.png");
		Image img = iPicto.getImage();
		Image newimg = img.getScaledInstance(75, 75, java.awt.Image.SCALE_SMOOTH);
		ImageIcon iUser = new ImageIcon(newimg);

		label1.setIcon(iUser);

		label1.setForeground(Color.white);
		label1.setBorder(new EmptyBorder(10, 10, 10, 10));
		label1.setFont(Global.FONT_ADMIN_TITLE);

		frmGenerador = new JButton(TXTGENERADOR);
		frmGenerador.setFont(Global.FONT_ADMIN_BUTTON);
		frmGenerador.setSelected(false);
		frmGenerador.setForeground(Global.COLOR_TEXTO_BOTON);
		frmGenerador.setName("frmCopiar");

		frmAdmin = new JButton(" ");
		frmAdmin.setBorderPainted(false);

		frmAdmin.setSelected(false);
		frmAdmin.setFocusable(false);
		frmNuevo = new JButton(TXTCREAR);
		frmNuevo.setFont(Global.FONT_ADMIN_BUTTON);

		frmNuevo.setSelected(false);
		frmNuevo.setForeground(Global.COLOR_TEXTO_BOTON);
		ImageIcon iuser = new ImageIcon("img/ADDUSER.png");
		frmNuevo.setIcon(iuser);
		frmNuevo.setName("frmNuevo");

		frmActPictogramas = new JButton(TXTUPDATEPICT);
		frmActPictogramas.setFont(Global.FONT_ADMIN_BUTTON);
		frmActPictogramas.setSelected(true);
		frmActPictogramas.setForeground(Global.COLOR_TEXTO_BOTON);
		frmActPictogramas.setEnabled(true);

		frmCopiar = new JButton(TXTEI);
		frmCopiar.setFont(Global.FONT_ADMIN_BUTTON);
		frmCopiar.setSelected(false);
		frmCopiar.setForeground(Global.COLOR_TEXTO_BOTON);
		ImageIcon iImEx = new ImageIcon("img/imex2.png");
		frmCopiar.setIcon(iImEx);
		frmCopiar.setName("frmCopiar");

		frmSalir = new JButton(TXTSALIR);
		frmSalir.setName("frmSalir");
		frmSalir.setSelected(false);
		frmSiguiente = new JButton(TXTSIGUIENTE);
		frmSiguiente.setName("frmSiguiente");
		frmSiguiente.setSelected(false);
		frmSiguiente.setFont(Global.FONT_ADMIN_TITLE);
		frmImportar = new JButton(TXTIMPORTAR);
		frmImportar.setFont(Global.FONT_ADMIN_BUTTON);
		frmImportar.setSelected(false);
		frmImportar.setForeground(Global.COLOR_TEXTO_BOTON);
		ImageIcon iuserI = new ImageIcon("img/IMUSER.png");
		frmImportar.setIcon(iuserI);

		nusers = DataUsers.countUsers();
		sigpag = siguientePag(pag, nusers);
		frmSiguiente.setActionCommand(String.valueOf(sigpag));
		this.setSize(wsize, hsize);
		this.setResizable(false);

		// int tampict = tamImgUsuario(nusers); // El tamaño de los botones según el número de usuarios
		int tampict = 40; // El tamaño de los botones según el número de usuarios

		frmUsuarios = DataUsers.getUsersButtons(tampict, tampict, 0); // todos

		nelementos = frmUsuarios.length;
		panelSuperior = new JPanel();
		panelInferior = new JPanel(new GridLayout(1, 4, 30, 50)); // Filas,Columnas
		panelSuperior.setLayout(new BoxLayout(panelSuperior, BoxLayout.X_AXIS));
		panelCentral = new JPanel(new GridLayout(3, 10, 1, 1)); // Filas,Columnas
		panelCentral.setBackground(Color.gray);

		label1.setSize(1000, label1.getHeight());
		panelSuperior.add(label1);
		panelSuperior.add(frmNuevo);
		panelSuperior.add(frmImportar);

		for (int x = 0; x < nusers; x++)
		{
			int l = (pag * NMAXPAGUSER) - NMAXPAGUSER;
			if((x >= l) && x < (l + NMAXPAGUSER))
			{
				frmUsuarios[x].addActionListener(this);
				//frmUsuarios[x].setContentAreaFilled(false);
				frmUsuarios[x].setOpaque(true);
				//frmUsuarios[x].setBackground(Global.COLOR_CONTENIDO);
				frmUsuarios[x].setFont(Global.FONT_ADMIN_USER);
				frmUsuarios[x].setForeground(Global.COLOR_TEXTO);
				panelCentral.add(frmUsuarios[x]);
			}
		}

		// panelInferior.add(frmNuevo);
		// panelInferior.add(frmImportar);
		panelInferior.add(frmCopiar);
		panelInferior.add(frmActPictogramas);
		panelInferior.add(frmGenerador);

		if(nusers > NMAXPAGUSER)
		{
			panelInferior.add(frmSiguiente);
		}

		poblar();

		frmGenerador.addActionListener(this);
		frmSalir.addActionListener(this);
		frmSiguiente.addActionListener(this);
		frmNuevo.addActionListener(this);
		frmCopiar.addActionListener(this);
		frmImportar.addActionListener(this);
		frmActPictogramas.addActionListener(this);
	}

	private int tamImgUsuario(int nuser)
	{
		int x = PICT_SIZE * (NMAXUSER / nuser);
		if(x > 100) x = 100;
		if(nuser > 10) x = 40;

		return x;
	}

	private void desactivarBotones()
	{
		// frmActPictogramas.setEnabled(false);
		frmActPictogramas.paintImmediately(frmActPictogramas.getVisibleRect());
		frmCopiar.setEnabled(false);
		frmCopiar.paintImmediately(frmCopiar.getVisibleRect());
		frmGenerador.setEnabled(false);
		frmGenerador.paintImmediately(frmGenerador.getVisibleRect());
		frmNuevo.setEnabled(false);
		frmNuevo.paintImmediately(frmNuevo.getVisibleRect());
		frmImportar.setEnabled(false);
		frmImportar.paintImmediately(frmImportar.getVisibleRect());

		for (int i = 0; i < frmUsuarios.length; i++)
		{
			frmUsuarios[i].setEnabled(false);
			frmUsuarios[i].paintImmediately(frmUsuarios[i].getVisibleRect());
		}
	}

	private void activarBotones()
	{
		frmActPictogramas.setEnabled(true);
		frmCopiar.setEnabled(true);
		frmGenerador.setEnabled(true);
		frmNuevo.setEnabled(true);
		frmImportar.setEnabled(true);

		for (int i = 0; i < frmUsuarios.length; i++)
			frmUsuarios[i].setEnabled(true);
	}

	private void actualizarBotonesUsuarios()
	{
		int sigpag, nusers, pag;

		nusers = DataUsers.countUsers();

		pag = this.nPagina = Integer.valueOf(frmSiguiente.getActionCommand()); // La pagina actual es la que era la siguiente
		sigpag = siguientePag(pag, nusers); // Nueva Pagina siguiente
		frmSiguiente.setActionCommand(String.valueOf(sigpag)); // La asigno
		// int tampict = tamImgUsuario(nusers); // El tamaño de los botones según el número de usuarios
		int tampict = 40;
		frmUsuarios = null; // Esto no le va a gustar a Hector
		frmUsuarios = DataUsers.getUsersButtons(tampict, tampict, 0); // todos

		panelCentral.removeAll(); // Elimino todos los componentes del panel central si estos existieran

		for (int x = 0; x < nusers; x++)
		{
			int l = (pag * NMAXPAGUSER) - NMAXPAGUSER;
			if((x >= l) && x < (l + NMAXPAGUSER))
			{
				frmUsuarios[x].addActionListener(this);
				//frmUsuarios[x].setContentAreaFilled(false);
				frmUsuarios[x].setOpaque(true);
				//frmUsuarios[x].setBackground(Global.COLOR_CONTENIDO);
				frmUsuarios[x].setFont(Global.FONT_ADMIN_USER);
				frmUsuarios[x].setForeground(Global.COLOR_TEXTO);
				panelCentral.add(frmUsuarios[x]);
			}
		}

		if(nusers > NMAXPAGUSER)
		{
			panelInferior.remove(frmSiguiente);
			panelInferior.add(frmSiguiente);
			frmSiguiente.addActionListener(this);
		}

		panelCentral.repaint();
		panelCentral.revalidate();
		panelInferior.repaint();
		panelInferior.revalidate();
	}

	private void poblar()
	{
		panelSuperior.setBackground(Global.COLOR_FONDO);
		panelCentral.setBorder(BorderFactory.createMatteBorder(1, 20, 1, 20, Global.COLOR_FONDO));
		panelInferior.setBackground(Global.COLOR_FONDO);
		panelInferior.setBorder(new EmptyBorder(20, 20, 20, 20));

		this.getContentPane().add(panelSuperior, BorderLayout.NORTH);
		this.getContentPane().add(panelCentral, BorderLayout.CENTER);
		this.getContentPane().add(panelInferior, BorderLayout.SOUTH);
	}

	private int siguientePag(int pagact, int nusers)
	{
		int x = pagact * NMAXPAGUSER;

		if(nusers > x)
		{
			return pagact + 1;
		}
		else
		{
			return 1;
		}
	}

	private int numPaginas(int nusuarios)
	{
		int r;
		if(nusuarios <= NMAXPAGUSER)
		{
			r = 1;
		}
		else
		{
			int x = nusuarios / NMAXPAGUSER;
			int k = nusuarios % NMAXPAGUSER;

			if(k == 0)
			{
				r = x;
			}
			else
			{
				r = x + 1;
			}
		}
		return r;
	}

	public void actionPerformed(ActionEvent ae)
	{
		for (int i = 0; i < frmUsuarios.length; i++)
		{
			if(ae.getSource() == frmUsuarios[i]) // Editar un usuario
			{
				String iduser = frmUsuarios[i].getActionCommand();
				if(sListaUsrCambio.isEmpty())
					sListaUsrCambio = frmUsuarios[i].getActionCommand();
				else
					sListaUsrCambio = sListaUsrCambio + Global.TOKEN_SEPARATOR + iduser;
				VentanaAdminUsuarioDetalle fr = new VentanaAdminUsuarioDetalle(Integer.parseInt(iduser), this);
				fr.setVisible(true);
				actualizarBotonesUsuarios();
			}
		}

		if(ae.getSource() == frmSiguiente)
		{
			VentanaAdminUsuarioSel frame = new VentanaAdminUsuarioSel(Integer.valueOf(frmSiguiente.getActionCommand()));
			frame.setBounds(this.getBounds());
			frame.setVisible(true);
			this.dispose();
		}
		else if(ae.getSource() == frmSalir)
		{
			try
			{
				this.finalize();
			}
			catch (Throwable e)
			{
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		else if(ae.getSource() == frmNuevo) // Nuevo usuario
		{
			int nusers = DataUsers.countUsers();
			if(nusers < NMAXUSER) // Comprueba que el número máximo de usuarios no se ha alcanzado
			{
				VentanaAdminUsuarioDetalle fr = new VentanaAdminUsuarioDetalle(Global.USER_DEFAULT_TEMP_ID, this);
				fr.setVisible(true);
				actualizarBotonesUsuarios();
			}
			else
			{
				JOptionPane.showMessageDialog(this, TXTMAXUSER);
			}
		}
		else if(ae.getSource() == frmCopiar) // Copiar ficheros
		{
			VentanaAdminCopiar fr = new VentanaAdminCopiar(this);
			fr.setVisible(true);
		}
		else if(ae.getSource() == frmImportar) // Importar
		{
			int nusers = DataUsers.countUsers();
			if(nusers < NMAXUSER) // Comprueba que el número máximo de usuarios no se ha alcanzado
			{
				importarUsuario();
				actualizarBotonesUsuarios();
			}
			else
			{
				JOptionPane.showMessageDialog(this, TXTMAXUSER);
			}
		}
		else if(ae.getSource() == frmActPictogramas && frmActPictogramas.getText().equals(TXTUPDATEPICT)) // Actualizar pictogramas
		{
			actualizarPictogramas();
		}
		else if(ae.getSource() == frmGenerador)
		{
			try
			{
				ImportarPicto ip = new ImportarPicto(this);
				ip.setVisible(true);
			}
			catch (Exception e)
			{
				System.out.println(e);
			}

		}
	}

	private void actualizarPictogramas()
	{
		JFileChooser fileChooser = new JFileChooser();
		fileChooser.setCurrentDirectory(new File(System.getProperty("user.home")));
		FileFilter filter1 = new ExtensionFileFilter("zip", new String[] { "zip" });
		fileChooser.setFileFilter(null);
		fileChooser.setFileFilter(filter1);
		int seleccion = fileChooser.showOpenDialog(rootPane);
		if(seleccion == JFileChooser.APPROVE_OPTION)
		{
			String ruta = fileChooser.getSelectedFile().getAbsolutePath();
			desactivarBotones();
			DataUsers.UpdatePicto(ruta, frmActPictogramas, TXTIMPORTANDOPICT);
			int errores = DataUsers.checkPicto();
			if(errores > 0) JOptionPane.showMessageDialog(this, TXTACTUALIZARERROR + " (" + errores + ")", "", JOptionPane.WARNING_MESSAGE);
			activarBotones();
			frmActPictogramas.setText(TXTUPDATEPICT);
		}
	}

	private void importarUsuario()
	{
		JFileChooser fileChooser = new JFileChooser();
		fileChooser.setCurrentDirectory(new File(System.getProperty("user.home")));
		FileFilter filter1 = new ExtensionFileFilter("cfg", new String[] { "cfg" });
		fileChooser.setFileFilter(filter1);
		int seleccion = fileChooser.showOpenDialog(rootPane);
		if(seleccion == JFileChooser.APPROVE_OPTION)
		{
			String ruta = fileChooser.getSelectedFile().getAbsolutePath();
			DataUsers.importProfile(ruta);
		}
	}

	public boolean AuthUser(String login, String pass)
	{
		return true;
	}

	/**
	 * Checks if the configuration of a given user may have changed. That is, if the button 
	 * corresponding to the user in the main administrative window has been pressed.
	 * @return True if the user's configuration has been changed. False if not.
	 * @author hqcasanova
	 */
	public boolean isUsrCambiado(int iIdUsr)
	{
		String sIdUsr = String.valueOf(iIdUsr);
		if (sListaUsrCambio.equals(sIdUsr) || sListaUsrCambio.startsWith(sIdUsr + Global.TOKEN_SEPARATOR) || 
			sListaUsrCambio.endsWith(Global.TOKEN_SEPARATOR + sIdUsr) ||
			(sListaUsrCambio.indexOf(Global.TOKEN_SEPARATOR + sIdUsr + Global.TOKEN_SEPARATOR) != -1)) {
		   return true;
		} else return false;
	}

	public static void main(String arg[])
	{
		try
		{
			VentanaAdminUsuarioSel frame = new VentanaAdminUsuarioSel(1);
			frame.setVisible(true);
		}
		catch (Exception e)
		{
			JOptionPane.showMessageDialog(null, e.getMessage());
		}
	}
}
